/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.66 Revision 1.115
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.66 2009/08/28 16:08:51 arfrever Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.115 2011/07/04 11:27:29 djc Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# python@gentoo.org 7# Gentoo Python Project <python@gentoo.org>
8# 8# @BLURB: Eclass for Python packages
9# original author: Alastair Tse <liquidx@gentoo.org>
10# @BLURB: A Utility Eclass that should be inherited by anything that deals with Python or Python modules.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# Some useful functions for dealing with Python. 10# The python eclass contains miscellaneous, useful functions for Python packages.
13 11
14inherit multilib 12inherit multilib
15 13
16if [[ -n "${NEED_PYTHON}" ]] ; then 14if ! has "${EAPI:-0}" 0 1 2 3; then
17 PYTHON_ATOM=">=dev-lang/python-${NEED_PYTHON}" 15 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
18 DEPEND="${PYTHON_ATOM}"
19 RDEPEND="${DEPEND}"
20else
21 PYTHON_ATOM="dev-lang/python"
22fi 16fi
23 17
24DEPEND="${DEPEND} >=app-shells/bash-3.2" 18_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
25if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 19_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.0 3.1 3.2 3.3)
26 DEPEND="${DEPEND} >=app-admin/eselect-python-20090804" 20_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython)
27fi 21_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]})
28 22
29__python_eclass_test() { 23# ================================================================================================
30 __python_version_extract 2.3 24# ===================================== HANDLING OF METADATA =====================================
31 echo -n "2.3 -> PYVER: $PYVER PYVER_MAJOR: $PYVER_MAJOR" 25# ================================================================================================
32 echo " PYVER_MINOR: $PYVER_MINOR PYVER_MICRO: $PYVER_MICRO"
33 __python_version_extract 2.3.4
34 echo -n "2.3.4 -> PYVER: $PYVER PYVER_MAJOR: $PYVER_MAJOR"
35 echo " PYVER_MINOR: $PYVER_MINOR PYVER_MICRO: $PYVER_MICRO"
36 __python_version_extract 2.3.5
37 echo -n "2.3.5 -> PYVER: $PYVER PYVER_MAJOR: $PYVER_MAJOR"
38 echo " PYVER_MINOR: $PYVER_MINOR PYVER_MICRO: $PYVER_MICRO"
39 __python_version_extract 2.4
40 echo -n "2.4 -> PYVER: $PYVER PYVER_MAJOR: $PYVER_MAJOR"
41 echo " PYVER_MINOR: $PYVER_MINOR PYVER_MICRO: $PYVER_MICRO"
42 __python_version_extract 2.5b3
43 echo -n "2.5b3 -> PYVER: $PYVER PYVER_MAJOR: $PYVER_MAJOR"
44 echo " PYVER_MINOR: $PYVER_MINOR PYVER_MICRO: $PYVER_MICRO"
45}
46 26
47# @FUNCTION: python_version 27_python_check_python_abi_matching() {
48# @DESCRIPTION: 28 local pattern patterns patterns_list="0" PYTHON_ABI
49# Run without arguments and it will export the version of python
50# currently in use as $PYVER; sets PYVER/PYVER_MAJOR/PYVER_MINOR
51__python_version_extract() {
52 local verstr=$1
53 export PYVER_MAJOR=${verstr:0:1}
54 export PYVER_MINOR=${verstr:2:1}
55 if [[ ${verstr:3:1} == . ]]; then
56 export PYVER_MICRO=${verstr:4}
57 fi
58 export PYVER="${PYVER_MAJOR}.${PYVER_MINOR}"
59}
60
61python_version() {
62 [[ -n "${PYVER}" ]] && return 0
63 local tmpstr
64 python=${python:-/usr/bin/python}
65 tmpstr="$(${python} -V 2>&1 )"
66 export PYVER_ALL="${tmpstr#Python }"
67 __python_version_extract $PYVER_ALL
68}
69
70# @FUNCTION: PYTHON
71# @USAGE: [-a|--absolute-path] <Python_ABI="${PYTHON_ABI}">
72# @DESCRIPTION:
73# Get Python interpreter filename for specified Python ABI. If Python_ABI argument
74# is ommitted, then PYTHON_ABI environment variable must be set and is used.
75PYTHON() {
76 local absolute_path="0" slot=
77 29
78 while (($#)); do 30 while (($#)); do
79 case "$1" in 31 case "$1" in
80 -a|--absolute-path) 32 --patterns-list)
81 absolute_path="1" 33 patterns_list="1"
34 ;;
35 --)
36 shift
37 break
82 ;; 38 ;;
83 -*) 39 -*)
84 die "${FUNCNAME}(): Unrecognized option $1" 40 die "${FUNCNAME}(): Unrecognized option '$1'"
85 ;; 41 ;;
86 *) 42 *)
87 break 43 break
88 ;; 44 ;;
89 esac 45 esac
90 shift 46 shift
91 done 47 done
92 48
93 if [[ "$#" -eq "0" ]]; then 49 if [[ "$#" -ne 2 ]]; then
94 if [[ -n "${PYTHON_ABI}" ]]; then 50 die "${FUNCNAME}() requires 2 arguments"
95 slot="${PYTHON_ABI}" 51 fi
52
53 PYTHON_ABI="$1"
54
55 if [[ "${patterns_list}" == "0" ]]; then
56 pattern="$2"
57
58 if [[ "${pattern}" == *"-cpython" ]]; then
59 [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ && "${PYTHON_ABI}" == ${pattern%-cpython} ]]
60 elif [[ "${pattern}" == *"-jython" ]]; then
61 [[ "${PYTHON_ABI}" == ${pattern} ]]
96 else 62 else
97 die "${FUNCNAME}(): Invalid usage" 63 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
64 [[ "${PYTHON_ABI}" == ${pattern} ]]
65 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
66 [[ "${PYTHON_ABI%-jython}" == ${pattern} ]]
67 else
68 die "${FUNCNAME}(): Unrecognized Python ABI '${PYTHON_ABI}'"
98 fi 69 fi
99 elif [[ "$#" -eq "1" ]]; then 70 fi
100 slot="$1" 71 else
72 patterns="${2// /$'\n'}"
73
74 while read pattern; do
75 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
76 return 0
77 fi
78 done <<< "${patterns}"
79
80 return 1
81 fi
82}
83
84# @ECLASS-VARIABLE: PYTHON_DEPEND
85# @DESCRIPTION:
86# Specification of dependency on dev-lang/python.
87# Syntax:
88# PYTHON_DEPEND: [[!]USE_flag? ]<version_components_group>[ version_components_group]
89# version_components_group: <major_version[:[minimal_version][:maximal_version]]>
90# major_version: <2|3|*>
91# minimal_version: <minimal_major_version.minimal_minor_version>
92# maximal_version: <maximal_major_version.maximal_minor_version>
93
94_python_parse_PYTHON_DEPEND() {
95 local major_version maximal_version minimal_version python_all="0" python_maximal_version python_minimal_version python_versions=() python2="0" python2_maximal_version python2_minimal_version python3="0" python3_maximal_version python3_minimal_version USE_flag= version_components_group version_components_group_regex version_components_groups
96
97 version_components_group_regex="(2|3|\*)(:([[:digit:]]+\.[[:digit:]]+)?(:([[:digit:]]+\.[[:digit:]]+)?)?)?"
98 version_components_groups="${PYTHON_DEPEND}"
99
100 if [[ "${version_components_groups}" =~ ^((\!)?[[:alnum:]_-]+\?\ )?${version_components_group_regex}(\ ${version_components_group_regex})?$ ]]; then
101 if [[ "${version_components_groups}" =~ ^(\!)?[[:alnum:]_-]+\? ]]; then
102 USE_flag="${version_components_groups%\? *}"
103 version_components_groups="${version_components_groups#* }"
104 fi
105 if [[ "${version_components_groups}" =~ ("*".*" "|" *"|^2.*\ (2|\*)|^3.*\ (3|\*)) ]]; then
106 die "Invalid syntax of PYTHON_DEPEND: Incorrectly specified groups of versions"
107 fi
108
109 version_components_groups="${version_components_groups// /$'\n'}"
110 while read version_components_group; do
111 major_version="${version_components_group:0:1}"
112 minimal_version="${version_components_group:2}"
113 minimal_version="${minimal_version%:*}"
114 maximal_version="${version_components_group:$((3 + ${#minimal_version}))}"
115
116 if [[ "${major_version}" =~ ^(2|3)$ ]]; then
117 if [[ -n "${minimal_version}" && "${major_version}" != "${minimal_version:0:1}" ]]; then
118 die "Invalid syntax of PYTHON_DEPEND: Minimal version '${minimal_version}' not in specified group of versions"
119 fi
120 if [[ -n "${maximal_version}" && "${major_version}" != "${maximal_version:0:1}" ]]; then
121 die "Invalid syntax of PYTHON_DEPEND: Maximal version '${maximal_version}' not in specified group of versions"
122 fi
123 fi
124
125 if [[ "${major_version}" == "2" ]]; then
126 python2="1"
127 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}")
128 python2_minimal_version="${minimal_version}"
129 python2_maximal_version="${maximal_version}"
130 elif [[ "${major_version}" == "3" ]]; then
131 python3="1"
132 python_versions=("${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
133 python3_minimal_version="${minimal_version}"
134 python3_maximal_version="${maximal_version}"
135 else
136 python_all="1"
137 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
138 python_minimal_version="${minimal_version}"
139 python_maximal_version="${maximal_version}"
140 fi
141
142 if [[ -n "${minimal_version}" ]] && ! has "${minimal_version}" "${python_versions[@]}"; then
143 die "Invalid syntax of PYTHON_DEPEND: Unrecognized minimal version '${minimal_version}'"
144 fi
145 if [[ -n "${maximal_version}" ]] && ! has "${maximal_version}" "${python_versions[@]}"; then
146 die "Invalid syntax of PYTHON_DEPEND: Unrecognized maximal version '${maximal_version}'"
147 fi
148
149 if [[ -n "${minimal_version}" && -n "${maximal_version}" && "${minimal_version}" > "${maximal_version}" ]]; then
150 die "Invalid syntax of PYTHON_DEPEND: Minimal version '${minimal_version}' greater than maximal version '${maximal_version}'"
151 fi
152 done <<< "${version_components_groups}"
153
154 _PYTHON_ATOMS=()
155
156 _append_accepted_versions_range() {
157 local accepted_version="0" i
158 for ((i = "${#python_versions[@]}"; i >= 0; i--)); do
159 if [[ "${python_versions[${i}]}" == "${python_maximal_version}" ]]; then
160 accepted_version="1"
161 fi
162 if [[ "${accepted_version}" == "1" ]]; then
163 _PYTHON_ATOMS+=("=dev-lang/python-${python_versions[${i}]}*")
164 fi
165 if [[ "${python_versions[${i}]}" == "${python_minimal_version}" ]]; then
166 accepted_version="0"
167 fi
168 done
169 }
170
171 if [[ "${python_all}" == "1" ]]; then
172 if [[ -z "${python_minimal_version}" && -z "${python_maximal_version}" ]]; then
173 _PYTHON_ATOMS+=("dev-lang/python")
174 else
175 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
176 python_minimal_version="${python_minimal_version:-${python_versions[0]}}"
177 python_maximal_version="${python_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
178 _append_accepted_versions_range
179 fi
101 else 180 else
102 die "${FUNCNAME}(): Invalid usage" 181 if [[ "${python3}" == "1" ]]; then
182 if [[ -z "${python3_minimal_version}" && -z "${python3_maximal_version}" ]]; then
183 _PYTHON_ATOMS+=("=dev-lang/python-3*")
184 else
185 python_versions=("${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
186 python_minimal_version="${python3_minimal_version:-${python_versions[0]}}"
187 python_maximal_version="${python3_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
188 _append_accepted_versions_range
189 fi
190 fi
191 if [[ "${python2}" == "1" ]]; then
192 if [[ -z "${python2_minimal_version}" && -z "${python2_maximal_version}" ]]; then
193 _PYTHON_ATOMS+=("=dev-lang/python-2*")
194 else
195 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}")
196 python_minimal_version="${python2_minimal_version:-${python_versions[0]}}"
197 python_maximal_version="${python2_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
198 _append_accepted_versions_range
199 fi
200 fi
103 fi 201 fi
104 202
105 if [[ "${absolute_path}" == "1" ]]; then 203 unset -f _append_accepted_versions_range
106 echo -n "/usr/bin/python${slot}" 204
205 if [[ "${#_PYTHON_ATOMS[@]}" -gt 1 ]]; then
206 DEPEND+="${DEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${_PYTHON_ATOMS[@]} )${USE_flag:+ )}"
207 RDEPEND+="${RDEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${_PYTHON_ATOMS[@]} )${USE_flag:+ )}"
107 else 208 else
108 echo -n "python${slot}" 209 DEPEND+="${DEPEND:+ }${USE_flag}${USE_flag:+? ( }${_PYTHON_ATOMS[@]}${USE_flag:+ )}"
210 RDEPEND+="${RDEPEND:+ }${USE_flag}${USE_flag:+? ( }${_PYTHON_ATOMS[@]}${USE_flag:+ )}"
109 fi 211 fi
212 else
213 die "Invalid syntax of PYTHON_DEPEND"
214 fi
110} 215}
111 216
112# @FUNCTION: validate_PYTHON_ABIS 217DEPEND=">=app-admin/eselect-python-20091230"
218RDEPEND="${DEPEND}"
219
220if [[ -n "${PYTHON_DEPEND}" ]]; then
221 _python_parse_PYTHON_DEPEND
222else
223 _PYTHON_ATOMS=("dev-lang/python")
224fi
225unset -f _python_parse_PYTHON_DEPEND
226
227if [[ -n "${NEED_PYTHON}" ]]; then
228 eerror "Use PYTHON_DEPEND variable instead of NEED_PYTHON variable."
229 die "NEED_PYTHON variable is banned"
230fi
231
232# @ECLASS-VARIABLE: PYTHON_USE_WITH
113# @DESCRIPTION: 233# @DESCRIPTION:
114# Make sure PYTHON_ABIS variable has valid value. 234# Set this to a space separated list of USE flags the Python slot in use must be built with.
115validate_PYTHON_ABIS() { 235
116 # Ensure that some functions cannot be accidentally successfully used in EAPI <= 2 without setting SUPPORT_PYTHON_ABIS variable. 236# @ECLASS-VARIABLE: PYTHON_USE_WITH_OR
117 if has "${EAPI:-0}" 0 1 2 && [[ -z "${SUPPORT_PYTHON_ABIS}" ]]; then 237# @DESCRIPTION:
118 die "${FUNCNAME}() cannot be used in this EAPI without setting SUPPORT_PYTHON_ABIS variable" 238# Set this to a space separated list of USE flags of which one must be turned on for the slot in use.
239
240# @ECLASS-VARIABLE: PYTHON_USE_WITH_OPT
241# @DESCRIPTION:
242# Set this to a name of a USE flag if you need to make either PYTHON_USE_WITH or
243# PYTHON_USE_WITH_OR atoms conditional under a USE flag.
244
245if ! has "${EAPI:-0}" 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then
246 _PYTHON_USE_WITH_ATOMS_ARRAY=()
247 if [[ -n "${PYTHON_USE_WITH}" ]]; then
248 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
249 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${PYTHON_USE_WITH// /,}]")
250 done
251 elif [[ -n "${PYTHON_USE_WITH_OR}" ]]; then
252 for _USE_flag in ${PYTHON_USE_WITH_OR}; do
253 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
254 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${_USE_flag}]")
255 done
256 done
257 unset _USE_flag
258 fi
259 if [[ "${#_PYTHON_USE_WITH_ATOMS_ARRAY[@]}" -gt 1 ]]; then
260 _PYTHON_USE_WITH_ATOMS="|| ( ${_PYTHON_USE_WITH_ATOMS_ARRAY[@]} )"
261 else
262 _PYTHON_USE_WITH_ATOMS="${_PYTHON_USE_WITH_ATOMS_ARRAY[@]}"
263 fi
264 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then
265 _PYTHON_USE_WITH_ATOMS="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOMS} )"
266 fi
267 DEPEND+=" ${_PYTHON_USE_WITH_ATOMS}"
268 RDEPEND+=" ${_PYTHON_USE_WITH_ATOMS}"
269 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY
270fi
271
272unset _PYTHON_ATOMS
273
274# ================================================================================================
275# =================================== MISCELLANEOUS FUNCTIONS ====================================
276# ================================================================================================
277
278_python_implementation() {
279 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
280 return 0
281 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
282 return 0
283 else
284 return 1
285 fi
286}
287
288_python_package_supporting_installation_for_multiple_python_abis() {
289 if [[ "${EBUILD_PHASE}" == "depend" ]]; then
290 die "${FUNCNAME}() cannot be used in global scope"
291 fi
292
293 if has "${EAPI:-0}" 0 1 2 3 4; then
294 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
295 return 0
296 else
297 return 1
119 fi 298 fi
299 else
300 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
301 fi
302}
120 303
304_python_abi-specific_local_scope() {
305 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]]
306}
307
308_python_initialize_prefix_variables() {
309 if has "${EAPI:-0}" 0 1 2; then
310 if [[ -n "${ROOT}" && -z "${EROOT}" ]]; then
311 EROOT="${ROOT%/}${EPREFIX}/"
312 fi
313 if [[ -n "${D}" && -z "${ED}" ]]; then
314 ED="${D%/}${EPREFIX}/"
315 fi
316 fi
317}
318
319unset PYTHON_SANITY_CHECKS_EXECUTED PYTHON_SKIP_SANITY_CHECKS
320
321_python_initial_sanity_checks() {
322 if [[ "$(declare -p PYTHON_SANITY_CHECKS_EXECUTED 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS_EXECUTED="* || " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " && -z "${PYTHON_SKIP_SANITY_CHECKS}" ]]; then
121 # Ensure that /usr/bin/python and /usr/bin/python-config are valid. 323 # Ensure that /usr/bin/python and /usr/bin/python-config are valid.
122 if [[ "$(readlink /usr/bin/python)" != "python-wrapper" ]]; then 324 if [[ "$(readlink "${EPREFIX}/usr/bin/python")" != "python-wrapper" ]]; then
325 eerror "'${EPREFIX}/usr/bin/python' is not valid symlink."
326 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
123 die "'/usr/bin/python' isn't valid symlink" 327 die "'${EPREFIX}/usr/bin/python' is not valid symlink"
124 fi 328 fi
125 if [[ "$(</usr/bin/python-config)" != *"Gentoo python-config wrapper script"* ]]; then 329 if [[ "$(<"${EPREFIX}/usr/bin/python-config")" != *"Gentoo python-config wrapper script"* ]]; then
330 eerror "'${EPREFIX}/usr/bin/python-config' is not valid script"
331 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
126 die "'/usr/bin/python-config' isn't valid script" 332 die "'${EPREFIX}/usr/bin/python-config' is not valid script"
127 fi 333 fi
334 fi
335}
128 336
129 # USE_${ABI_TYPE^^} and RESTRICT_${ABI_TYPE^^}_ABIS variables hopefully will be included in EAPI >= 4. 337_python_final_sanity_checks() {
130 if [[ -z "${PYTHON_ABIS}" ]] && has "${EAPI:-0}" 0 1 2 3; then 338 if ! _python_implementation && [[ "$(declare -p PYTHON_SANITY_CHECKS_EXECUTED 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS_EXECUTED="* || " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " && -z "${PYTHON_SKIP_SANITY_CHECKS}" ]]; then
131 local ABI support_ABI supported_PYTHON_ABIS= restricted_ABI 339 local PYTHON_ABI="${PYTHON_ABI}"
132 PYTHON_ABI_SUPPORTED_VALUES="2.4 2.5 2.6 2.7 3.0 3.1 3.2" 340 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI}}; do
133 for ABI in ${USE_PYTHON}; do 341 # Ensure that appropriate version of Python is installed.
134 if ! has "${ABI}" ${PYTHON_ABI_SUPPORTED_VALUES}; then 342 if ! has_version "$(python_get_implementational_package)"; then
135 ewarn "Ignoring unsupported Python ABI '${ABI}'" 343 die "$(python_get_implementational_package) is not installed"
136 continue 344 fi
345
346 # Ensure that EPYTHON variable is respected.
347 if [[ "$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")" != "${PYTHON_ABI}" ]]; then
348 eerror "Path to 'python': '$(type -p python)'"
349 eerror "ABI: '${ABI}'"
350 eerror "DEFAULT_ABI: '${DEFAULT_ABI}'"
351 eerror "EPYTHON: '$(PYTHON)'"
352 eerror "PYTHON_ABI: '${PYTHON_ABI}'"
353 eerror "Locally active version of Python: '$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")'"
354 die "'python' does not respect EPYTHON variable"
355 fi
356 done
357 fi
358 PYTHON_SANITY_CHECKS_EXECUTED="1"
359}
360
361# @ECLASS-VARIABLE: PYTHON_COLORS
362# @DESCRIPTION:
363# User-configurable colored output.
364PYTHON_COLORS="${PYTHON_COLORS:-0}"
365
366_python_set_color_variables() {
367 if [[ "${PYTHON_COLORS}" != "0" && "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then
368 _BOLD=$'\e[1m'
369 _RED=$'\e[1;31m'
370 _GREEN=$'\e[1;32m'
371 _BLUE=$'\e[1;34m'
372 _CYAN=$'\e[1;36m'
373 _NORMAL=$'\e[0m'
374 else
375 _BOLD=
376 _RED=
377 _GREEN=
378 _BLUE=
379 _CYAN=
380 _NORMAL=
381 fi
382}
383
384unset PYTHON_PKG_SETUP_EXECUTED
385
386_python_check_python_pkg_setup_execution() {
387 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return
388
389 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then
390 die "python_pkg_setup() not called"
391 fi
392}
393
394# @FUNCTION: python_pkg_setup
395# @DESCRIPTION:
396# Perform sanity checks and initialize environment.
397#
398# This function is exported in EAPI 2 and 3 when PYTHON_USE_WITH or PYTHON_USE_WITH_OR variable
399# is set and always in EAPI >=4. Calling of this function is mandatory in EAPI >=4.
400python_pkg_setup() {
401 if [[ "${EBUILD_PHASE}" != "setup" ]]; then
402 die "${FUNCNAME}() can be used only in pkg_setup() phase"
403 fi
404
405 if [[ "$#" -ne 0 ]]; then
406 die "${FUNCNAME}() does not accept arguments"
407 fi
408
409 export JYTHON_SYSTEM_CACHEDIR="1"
410 addwrite "${EPREFIX}/var/cache/jython"
411
412 if _python_package_supporting_installation_for_multiple_python_abis; then
413 _python_calculate_PYTHON_ABIS
414 export EPYTHON="$(PYTHON -f)"
415 else
416 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
417 fi
418
419 if ! has "${EAPI:-0}" 0 1 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; then
420 if [[ "${PYTHON_USE_WITH_OPT}" ]]; then
421 if [[ "${PYTHON_USE_WITH_OPT}" == !* ]]; then
422 use ${PYTHON_USE_WITH_OPT#!} && return
423 else
424 use !${PYTHON_USE_WITH_OPT} && return
425 fi
426 fi
427
428 python_pkg_setup_check_USE_flags() {
429 local python_atom USE_flag
430 python_atom="$(python_get_implementational_package)"
431
432 for USE_flag in ${PYTHON_USE_WITH}; do
433 if ! has_version "${python_atom}[${USE_flag}]"; then
434 eerror "Please rebuild ${python_atom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
435 die "Please rebuild ${python_atom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
137 fi 436 fi
437 done
438
439 for USE_flag in ${PYTHON_USE_WITH_OR}; do
440 if has_version "${python_atom}[${USE_flag}]"; then
441 return
442 fi
443 done
444
445 if [[ ${PYTHON_USE_WITH_OR} ]]; then
446 eerror "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
447 die "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
448 fi
449 }
450
451 if _python_package_supporting_installation_for_multiple_python_abis; then
452 PYTHON_SKIP_SANITY_CHECKS="1" python_execute_function -q python_pkg_setup_check_USE_flags
453 else
454 python_pkg_setup_check_USE_flags
455 fi
456
457 unset -f python_pkg_setup_check_USE_flags
458 fi
459
460 PYTHON_PKG_SETUP_EXECUTED="1"
461}
462
463if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
464 EXPORT_FUNCTIONS pkg_setup
465fi
466
467_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|python)'
468
469# @FUNCTION: python_convert_shebangs
470# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories]
471# @DESCRIPTION:
472# Convert shebangs in specified files. Directories can be specified only with --recursive option.
473python_convert_shebangs() {
474 _python_check_python_pkg_setup_execution
475
476 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0"
477
478 while (($#)); do
479 case "$1" in
480 -r|--recursive)
481 recursive="1"
482 ;;
483 -q|--quiet)
484 quiet="1"
485 ;;
486 -x|--only-executables)
487 only_executables="1"
488 ;;
489 --)
490 shift
491 break
492 ;;
493 -*)
494 die "${FUNCNAME}(): Unrecognized option '$1'"
495 ;;
496 *)
497 break
498 ;;
499 esac
500 shift
501 done
502
503 if [[ "$#" -eq 0 ]]; then
504 die "${FUNCNAME}(): Missing Python version and files or directories"
505 elif [[ "$#" -eq 1 ]]; then
506 die "${FUNCNAME}(): Missing files or directories"
507 fi
508
509 if [[ -n "$(_python_get_implementation --ignore-invalid "$1")" ]]; then
510 python_interpreter="$(PYTHON "$1")"
511 else
512 python_interpreter="python$1"
513 fi
514 shift
515
516 for argument in "$@"; do
517 if [[ ! -e "${argument}" ]]; then
518 die "${FUNCNAME}(): '${argument}' does not exist"
519 elif [[ -f "${argument}" ]]; then
520 files+=("${argument}")
521 elif [[ -d "${argument}" ]]; then
522 if [[ "${recursive}" == "1" ]]; then
523 while read -d $'\0' -r file; do
524 files+=("${file}")
525 done < <(find "${argument}" $([[ "${only_executables}" == "1" ]] && echo -perm /111) -type f -print0)
526 else
527 die "${FUNCNAME}(): '${argument}' is not a regular file"
528 fi
529 else
530 die "${FUNCNAME}(): '${argument}' is not a regular file or a directory"
531 fi
532 done
533
534 for file in "${files[@]}"; do
535 file="${file#./}"
536 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
537
538 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then
539 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
540
541 if [[ "${quiet}" == "0" ]]; then
542 einfo "Converting shebang in '${file}'"
543 fi
544
545 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed"
546 fi
547 done
548}
549
550# @FUNCTION: python_clean_installation_image
551# @USAGE: [-q|--quiet]
552# @DESCRIPTION:
553# Delete needless files in installation image.
554#
555# This function can be used only in src_install() phase.
556python_clean_installation_image() {
557 if [[ "${EBUILD_PHASE}" != "install" ]]; then
558 die "${FUNCNAME}() can be used only in src_install() phase"
559 fi
560
561 _python_check_python_pkg_setup_execution
562 _python_initialize_prefix_variables
563
564 local file files=() quiet="0"
565
566 while (($#)); do
567 case "$1" in
568 -q|--quiet)
569 quiet="1"
570 ;;
571 -*)
572 die "${FUNCNAME}(): Unrecognized option '$1'"
573 ;;
574 *)
575 die "${FUNCNAME}(): Invalid usage"
576 ;;
577 esac
578 shift
579 done
580
581 while read -d $'\0' -r file; do
582 files+=("${file}")
583 done < <(find "${ED}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -type f -print0)
584
585 if [[ "${#files[@]}" -gt 0 ]]; then
586 if [[ "${quiet}" == "0" ]]; then
587 ewarn "Deleting byte-compiled Python modules needlessly generated by build system:"
588 fi
589 for file in "${files[@]}"; do
590 if [[ "${quiet}" == "0" ]]; then
591 ewarn " ${file}"
592 fi
593 rm -f "${file}"
594
595 # Delete empty __pycache__ directories.
596 if [[ "${file%/*}" == *"/__pycache__" ]]; then
597 rmdir "${file%/*}" 2> /dev/null
598 fi
599 done
600 fi
601
602 python_clean_sitedirs() {
603 if [[ -d "${ED}$(python_get_sitedir)" ]]; then
604 find "${ED}$(python_get_sitedir)" "(" -name "*.c" -o -name "*.h" -o -name "*.la" ")" -type f -print0 | xargs -0 rm -f
605 fi
606 }
607 if _python_package_supporting_installation_for_multiple_python_abis; then
608 python_execute_function -q python_clean_sitedirs
609 else
610 python_clean_sitedirs
611 fi
612
613 unset -f python_clean_sitedirs
614}
615
616# ================================================================================================
617# =========== FUNCTIONS FOR PACKAGES SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ============
618# ================================================================================================
619
620# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS
621# @DESCRIPTION:
622# Set this in EAPI <= 4 to indicate that current package supports installation for
623# multiple Python ABIs.
624
625# @ECLASS-VARIABLE: PYTHON_EXPORT_PHASE_FUNCTIONS
626# @DESCRIPTION:
627# Set this to export phase functions for the following ebuild phases:
628# src_prepare(), src_configure(), src_compile(), src_test(), src_install().
629if ! has "${EAPI:-0}" 0 1; then
630 python_src_prepare() {
631 if [[ "${EBUILD_PHASE}" != "prepare" ]]; then
632 die "${FUNCNAME}() can be used only in src_prepare() phase"
633 fi
634
635 if ! _python_package_supporting_installation_for_multiple_python_abis; then
636 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
637 fi
638
639 _python_check_python_pkg_setup_execution
640
641 if [[ "$#" -ne 0 ]]; then
642 die "${FUNCNAME}() does not accept arguments"
643 fi
644
645 python_copy_sources
646 }
647
648 for python_default_function in src_configure src_compile src_test; do
649 eval "python_${python_default_function}() {
650 if [[ \"\${EBUILD_PHASE}\" != \"${python_default_function#src_}\" ]]; then
651 die \"\${FUNCNAME}() can be used only in ${python_default_function}() phase\"
652 fi
653
654 if ! _python_package_supporting_installation_for_multiple_python_abis; then
655 die \"\${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs\"
656 fi
657
658 _python_check_python_pkg_setup_execution
659
660 python_execute_function -d -s -- \"\$@\"
661 }"
662 done
663 unset python_default_function
664
665 python_src_install() {
666 if [[ "${EBUILD_PHASE}" != "install" ]]; then
667 die "${FUNCNAME}() can be used only in src_install() phase"
668 fi
669
670 if ! _python_package_supporting_installation_for_multiple_python_abis; then
671 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
672 fi
673
674 _python_check_python_pkg_setup_execution
675
676 if has "${EAPI:-0}" 0 1 2 3; then
677 python_execute_function -d -s -- "$@"
678 else
679 python_installation() {
680 emake DESTDIR="${T}/images/${PYTHON_ABI}" install "$@"
681 }
682 python_execute_function -s python_installation "$@"
683 unset python_installation
684
685 python_merge_intermediate_installation_images "${T}/images"
686 fi
687 }
688
689 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then
690 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install
691 fi
692fi
693
694if has "${EAPI:-0}" 0 1 2 3 4; then
695 unset PYTHON_ABIS
696fi
697
698_python_calculate_PYTHON_ABIS() {
699 if ! _python_package_supporting_installation_for_multiple_python_abis; then
700 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
701 fi
702
703 _python_initial_sanity_checks
704
705 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then
706 local PYTHON_ABI restricted_ABI restricted_ABIs support_ABI supported_PYTHON_ABIS
707
708 restricted_ABIs="${RESTRICT_PYTHON_ABIS// /$'\n'}"
709
710 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then
711 local cpython_enabled="0"
712
713 if [[ -z "${USE_PYTHON}" ]]; then
714 die "USE_PYTHON variable is empty"
715 fi
716
717 for PYTHON_ABI in ${USE_PYTHON}; do
718 if ! has "${PYTHON_ABI}" "${_PYTHON_GLOBALLY_SUPPORTED_ABIS[@]}"; then
719 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'"
720 fi
721
722 if has "${PYTHON_ABI}" "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; then
723 cpython_enabled="1"
724 fi
725
138 support_ABI="1" 726 support_ABI="1"
139 if [[ -z "${IGNORE_RESTRICT_PYTHON_ABIS}" ]]; then 727 while read restricted_ABI; do
140 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 728 if _python_check_python_abi_matching "${PYTHON_ABI}" "${restricted_ABI}"; then
141 if python -c "from fnmatch import fnmatch; exit(not fnmatch('${ABI}', '${restricted_ABI}'))"; then
142 support_ABI="0" 729 support_ABI="0"
143 break 730 break
144 fi 731 fi
732 done <<< "${restricted_ABIs}"
733 [[ "${support_ABI}" == "1" ]] && export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
734 done
735
736 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
737 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}"
738 fi
739
740 if [[ "${cpython_enabled}" == "0" ]]; then
741 die "USE_PYTHON variable does not enable any CPython ABI"
742 fi
743 else
744 local python_version python2_version python3_version support_python_major_version
745
746 if ! has_version "dev-lang/python"; then
747 die "${FUNCNAME}(): 'dev-lang/python' is not installed"
748 fi
749
750 python_version="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
751
752 if has_version "=dev-lang/python-2*"; then
753 if [[ "$(readlink "${EPREFIX}/usr/bin/python2")" != "python2."* ]]; then
754 die "'${EPREFIX}/usr/bin/python2' is not valid symlink"
755 fi
756
757 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
758
759 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
760 support_python_major_version="1"
761 while read restricted_ABI; do
762 if _python_check_python_abi_matching "${PYTHON_ABI}" "${restricted_ABI}"; then
763 support_python_major_version="0"
764 fi
765 done <<< "${restricted_ABIs}"
766 [[ "${support_python_major_version}" == "1" ]] && break
145 done 767 done
768 if [[ "${support_python_major_version}" == "1" ]]; then
769 while read restricted_ABI; do
770 if _python_check_python_abi_matching "${python2_version}" "${restricted_ABI}"; then
771 die "Active version of CPython 2 is not supported by ${CATEGORY}/${PF}"
772 fi
773 done <<< "${restricted_ABIs}"
774 else
775 python2_version=""
146 fi 776 fi
147 [[ "${support_ABI}" == "1" ]] && supported_PYTHON_ABIS+=" ${ABI}" 777 fi
778
779 if has_version "=dev-lang/python-3*"; then
780 if [[ "$(readlink "${EPREFIX}/usr/bin/python3")" != "python3."* ]]; then
781 die "'${EPREFIX}/usr/bin/python3' is not valid symlink"
782 fi
783
784 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
785
786 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
787 support_python_major_version="1"
788 while read restricted_ABI; do
789 if _python_check_python_abi_matching "${PYTHON_ABI}" "${restricted_ABI}"; then
790 support_python_major_version="0"
791 fi
792 done <<< "${restricted_ABIs}"
793 [[ "${support_python_major_version}" == "1" ]] && break
794 done
795 if [[ "${support_python_major_version}" == "1" ]]; then
796 while read restricted_ABI; do
797 if _python_check_python_abi_matching "${python3_version}" "${restricted_ABI}"; then
798 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}"
799 fi
800 done <<< "${restricted_ABIs}"
801 else
802 python3_version=""
803 fi
804 fi
805
806 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then
807 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python2' symlink"
808 eerror "is set incorrectly. Use \`eselect python\` to fix configuration."
809 die "Incorrect configuration of Python"
810 fi
811 if [[ -n "${python3_version}" && "${python_version}" == "3."* && "${python_version}" != "${python3_version}" ]]; then
812 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python3' symlink"
813 eerror "is set incorrectly. Use \`eselect python\` to fix configuration."
814 die "Incorrect configuration of Python"
815 fi
816
817 PYTHON_ABIS="${python2_version} ${python3_version}"
818 PYTHON_ABIS="${PYTHON_ABIS# }"
819 export PYTHON_ABIS="${PYTHON_ABIS% }"
820 fi
821 fi
822
823 _python_final_sanity_checks
824}
825
826_python_prepare_flags() {
827 local array=() deleted_flag element flags new_value old_flag old_value operator pattern prefix variable
828
829 for variable in CPPFLAGS CFLAGS CXXFLAGS LDFLAGS; do
830 eval "_PYTHON_SAVED_${variable}=\"\${!variable}\""
831 for prefix in PYTHON_USER_ PYTHON_; do
832 if [[ "$(declare -p ${prefix}${variable} 2> /dev/null)" == "declare -a ${prefix}${variable}="* ]]; then
833 eval "array=(\"\${${prefix}${variable}[@]}\")"
834 for element in "${array[@]}"; do
835 if [[ "${element}" =~ ^([[:alnum:]]|\.|-|\*|\[|\])+\ (\+|-)\ .+ ]]; then
836 pattern="${element%% *}"
837 element="${element#* }"
838 operator="${element%% *}"
839 flags="${element#* }"
840 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
841 if [[ "${operator}" == "+" ]]; then
842 eval "export ${variable}+=\"\${variable:+ }${flags}\""
843 elif [[ "${operator}" == "-" ]]; then
844 flags="${flags// /$'\n'}"
845 old_value="${!variable// /$'\n'}"
846 new_value=""
847 while read old_flag; do
848 while read deleted_flag; do
849 if [[ "${old_flag}" == ${deleted_flag} ]]; then
850 continue 2
851 fi
852 done <<< "${flags}"
853 new_value+="${new_value:+ }${old_flag}"
854 done <<< "${old_value}"
855 eval "export ${variable}=\"\${new_value}\""
856 fi
857 fi
858 else
859 die "Element '${element}' of ${prefix}${variable} array has invalid syntax"
860 fi
861 done
862 elif [[ -n "$(declare -p ${prefix}${variable} 2> /dev/null)" ]]; then
863 die "${prefix}${variable} should be indexed array"
864 fi
148 done 865 done
149 export PYTHON_ABIS="${supported_PYTHON_ABIS# }"
150 fi
151
152 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
153 python_version
154 export PYTHON_ABIS="${PYVER}"
155 fi
156
157 # Ensure that EPYTHON variable is respected.
158 local PYTHON_ABI
159 for PYTHON_ABI in ${PYTHON_ABIS}; do
160 if [[ "$(EPYTHON="$(PYTHON)" python -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')" != "${PYTHON_ABI}" ]]; then
161 die "'python' doesn't respect EPYTHON variable"
162 fi
163 done
164}
165
166# @FUNCTION: python_copy_sources
167# @USAGE: [directory]
168# @DESCRIPTION:
169# Copy unpacked sources of given package for each Python ABI.
170python_copy_sources() {
171 local dir dirs=() PYTHON_ABI
172
173 if [[ "$#" -eq "0" ]]; then
174 if [[ "${WORKDIR}" == "${S}" ]]; then
175 die "${FUNCNAME}() cannot be used"
176 fi
177 dirs="${S}"
178 else
179 dirs="$@"
180 fi
181
182 validate_PYTHON_ABIS
183 for PYTHON_ABI in ${PYTHON_ABIS}; do
184 for dir in "${dirs[@]}"; do
185 cp -lpr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed"
186 done 866 done
187 done
188} 867}
189 868
190# @FUNCTION: python_set_build_dir_symlink 869_python_restore_flags() {
191# @USAGE: [directory="build"] 870 local variable
192# @DESCRIPTION:
193# Create build directory symlink.
194python_set_build_dir_symlink() {
195 local dir="$1"
196 871
197 [[ -z "${PYTHON_ABI}" ]] && die "PYTHON_ABI variable not set" 872 for variable in CPPFLAGS CFLAGS CXXFLAGS LDFLAGS; do
198 [[ -z "${dir}" ]] && dir="build" 873 eval "${variable}=\"\${_PYTHON_SAVED_${variable}}\""
199 874 unset _PYTHON_SAVED_${variable}
200 # Don't delete preexistent directories. 875 done
201 rm -f "${dir}" || die "Deletion of '${dir}' failed"
202 ln -s "${dir}-${PYTHON_ABI}" "${dir}" || die "Creation of '${dir}' directory symlink failed"
203} 876}
204 877
205# @FUNCTION: python_execute_function 878# @FUNCTION: python_execute_function
206# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] <function> [arguments] 879# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [-f|--final-ABI] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments]
207# @DESCRIPTION: 880# @DESCRIPTION:
208# Execute specified function for each value of PYTHON_ABIS, optionally passing additional 881# Execute specified function for each value of PYTHON_ABIS, optionally passing additional
209# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables. 882# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables.
210python_execute_function() { 883python_execute_function() {
211 local action action_message action_message_template= default_function="0" failure_message failure_message_template= function nonfatal="0" PYTHON_ABI quiet="0" separate_build_dirs="0" 884 if ! _python_package_supporting_installation_for_multiple_python_abis; then
885 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
886 fi
887
888 _python_check_python_pkg_setup_execution
889 _python_set_color_variables
890
891 local action action_message action_message_template default_function="0" failure_message failure_message_template final_ABI="0" function iterated_PYTHON_ABIS nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" return_code separate_build_dirs="0" source_dir
212 892
213 while (($#)); do 893 while (($#)); do
214 case "$1" in 894 case "$1" in
215 --action-message) 895 --action-message)
216 action_message_template="$2" 896 action_message_template="$2"
221 ;; 901 ;;
222 --failure-message) 902 --failure-message)
223 failure_message_template="$2" 903 failure_message_template="$2"
224 shift 904 shift
225 ;; 905 ;;
906 -f|--final-ABI)
907 final_ABI="1"
908 ;;
226 --nonfatal) 909 --nonfatal)
227 nonfatal="1" 910 nonfatal="1"
228 ;; 911 ;;
229 -q|--quiet) 912 -q|--quiet)
230 quiet="1" 913 quiet="1"
231 ;; 914 ;;
232 -s|--separate-build-dirs) 915 -s|--separate-build-dirs)
233 separate_build_dirs="1" 916 separate_build_dirs="1"
234 ;; 917 ;;
918 --source-dir)
919 source_dir="$2"
920 shift
921 ;;
922 --)
923 shift
924 break
925 ;;
235 -*) 926 -*)
236 die "${FUNCNAME}(): Unrecognized option $1" 927 die "${FUNCNAME}(): Unrecognized option '$1'"
237 ;; 928 ;;
238 *) 929 *)
239 break 930 break
240 ;; 931 ;;
241 esac 932 esac
242 shift 933 shift
243 done 934 done
244 935
936 if [[ -n "${source_dir}" && "${separate_build_dirs}" == 0 ]]; then
937 die "${FUNCNAME}(): '--source-dir' option can be specified only with '--separate-build-dirs' option"
938 fi
939
245 if [[ "${default_function}" == "0" ]]; then 940 if [[ "${default_function}" == "0" ]]; then
246 if [[ "$#" -eq "0" ]]; then 941 if [[ "$#" -eq 0 ]]; then
247 die "${FUNCNAME}(): Missing function name" 942 die "${FUNCNAME}(): Missing function name"
248 fi 943 fi
249 function="$1" 944 function="$1"
250 shift 945 shift
251 else 946
252 if [[ "$#" -ne "0" ]]; then 947 if [[ -z "$(type -t "${function}")" ]]; then
253 die "${FUNCNAME}(): --default-function option and function name cannot be specified simultaneously" 948 die "${FUNCNAME}(): '${function}' function is not defined"
254 fi 949 fi
950 else
255 if has "${EAPI:-0}" 0 1; then 951 if has "${EAPI:-0}" 0 1; then
256 die "${FUNCNAME}(): --default-function option cannot be used in this EAPI" 952 die "${FUNCNAME}(): '--default-function' option cannot be used in this EAPI"
257 fi 953 fi
258 954
259 if [[ "${EBUILD_PHASE}" == "configure" ]]; then 955 if [[ "${EBUILD_PHASE}" == "configure" ]]; then
260 if has "${EAPI}" 2; then 956 if has "${EAPI}" 2 3; then
261 python_default_function() { 957 python_default_function() {
262 econf 958 econf "$@"
263 } 959 }
264 else 960 else
265 python_default_function() { 961 python_default_function() {
266 nonfatal econf 962 nonfatal econf "$@"
267 } 963 }
268 fi 964 fi
269 elif [[ "${EBUILD_PHASE}" == "compile" ]]; then 965 elif [[ "${EBUILD_PHASE}" == "compile" ]]; then
270 python_default_function() { 966 python_default_function() {
271 emake 967 emake "$@"
272 } 968 }
273 elif [[ "${EBUILD_PHASE}" == "test" ]]; then 969 elif [[ "${EBUILD_PHASE}" == "test" ]]; then
274 python_default_function() { 970 python_default_function() {
275 if emake -j1 -n check &> /dev/null; then 971 if emake -j1 -n check &> /dev/null; then
276 emake -j1 check 972 emake -j1 check "$@"
277 elif emake -j1 -n test &> /dev/null; then 973 elif emake -j1 -n test &> /dev/null; then
278 emake -j1 test 974 emake -j1 test "$@"
279 fi 975 fi
280 } 976 }
281 elif [[ "${EBUILD_PHASE}" == "install" ]]; then 977 elif [[ "${EBUILD_PHASE}" == "install" ]]; then
282 python_default_function() { 978 python_default_function() {
283 emake DESTDIR="${D}" install 979 emake DESTDIR="${D}" install "$@"
284 } 980 }
285 else 981 else
286 die "${FUNCNAME}(): --default-function option cannot be used in this ebuild phase" 982 die "${FUNCNAME}(): '--default-function' option cannot be used in this ebuild phase"
287 fi 983 fi
288 function="python_default_function" 984 function="python_default_function"
985 fi
986
987 # Ensure that python_execute_function() cannot be directly or indirectly called by python_execute_function().
988 if _python_abi-specific_local_scope; then
989 die "${FUNCNAME}(): Invalid call stack"
289 fi 990 fi
290 991
291 if [[ "${quiet}" == "0" ]]; then 992 if [[ "${quiet}" == "0" ]]; then
292 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up" 993 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up"
293 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking" 994 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking"
300 [[ "${EBUILD_PHASE}" == "postinst" ]] && action="Postinstallation" 1001 [[ "${EBUILD_PHASE}" == "postinst" ]] && action="Postinstallation"
301 [[ "${EBUILD_PHASE}" == "prerm" ]] && action="Preuninstallation" 1002 [[ "${EBUILD_PHASE}" == "prerm" ]] && action="Preuninstallation"
302 [[ "${EBUILD_PHASE}" == "postrm" ]] && action="Postuninstallation" 1003 [[ "${EBUILD_PHASE}" == "postrm" ]] && action="Postuninstallation"
303 fi 1004 fi
304 1005
305 local RED GREEN BLUE NORMAL 1006 _python_calculate_PYTHON_ABIS
306 if [[ "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then 1007 if [[ "${final_ABI}" == "1" ]]; then
307 RED=$'\e[1;31m' 1008 iterated_PYTHON_ABIS="$(PYTHON -f --ABI)"
308 GREEN=$'\e[1;32m'
309 BLUE=$'\e[1;34m'
310 NORMAL=$'\e[0m'
311 else 1009 else
312 RED= 1010 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
313 GREEN=
314 BLUE=
315 NORMAL=
316 fi 1011 fi
317
318 validate_PYTHON_ABIS
319 for PYTHON_ABI in ${PYTHON_ABIS}; do 1012 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
1013 _python_prepare_flags
1014
320 if [[ "${quiet}" == "0" ]]; then 1015 if [[ "${quiet}" == "0" ]]; then
321 if [[ -n "${action_message_template}" ]]; then 1016 if [[ -n "${action_message_template}" ]]; then
322 action_message="$(eval echo -n "${action_message_template}")" 1017 eval "action_message=\"${action_message_template}\""
323 else 1018 else
324 action_message="${action} of ${CATEGORY}/${PF} with Python ${PYTHON_ABI}..." 1019 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version)..."
325 fi 1020 fi
326 echo " ${GREEN}*${NORMAL} ${BLUE}${action_message}${NORMAL}" 1021 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}"
327 fi 1022 fi
328 1023
329 if [[ "${separate_build_dirs}" == "1" ]]; then 1024 if [[ "${separate_build_dirs}" == "1" ]]; then
1025 if [[ -n "${source_dir}" ]]; then
1026 export BUILDDIR="${S}/${source_dir}-${PYTHON_ABI}"
1027 else
330 export BUILDDIR="${S}-${PYTHON_ABI}" 1028 export BUILDDIR="${S}-${PYTHON_ABI}"
1029 fi
331 pushd "${BUILDDIR}" > /dev/null || die "pushd failed" 1030 pushd "${BUILDDIR}" > /dev/null || die "pushd failed"
332 else 1031 else
333 export BUILDDIR="${S}" 1032 export BUILDDIR="${S}"
334 fi 1033 fi
335 1034
1035 previous_directory="$(pwd)"
1036 previous_directory_stack="$(dirs -p)"
1037 previous_directory_stack_length="$(dirs -p | wc -l)"
1038
336 if ! has "${EAPI}" 0 1 2 && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then 1039 if ! has "${EAPI}" 0 1 2 3 && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then
337 EPYTHON="$(PYTHON)" nonfatal "${function}" "$@" 1040 EPYTHON="$(PYTHON)" nonfatal "${function}" "$@"
338 else 1041 else
339 EPYTHON="$(PYTHON)" "${function}" "$@" 1042 EPYTHON="$(PYTHON)" "${function}" "$@"
340 fi 1043 fi
341 1044
342 if [[ "$?" != "0" ]]; then 1045 return_code="$?"
1046
1047 _python_restore_flags
1048
1049 if [[ "${return_code}" -ne 0 ]]; then
343 if [[ -n "${failure_message_template}" ]]; then 1050 if [[ -n "${failure_message_template}" ]]; then
344 failure_message="$(eval echo -n "${failure_message_template}")" 1051 eval "failure_message=\"${failure_message_template}\""
345 else 1052 else
346 failure_message="${action} failed with Python ${PYTHON_ABI} in ${function}() function" 1053 failure_message="${action} failed with $(python_get_implementation) $(python_get_version) in ${function}() function"
347 fi 1054 fi
348 1055
349 if [[ "${nonfatal}" == "1" ]] || has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then 1056 if [[ "${nonfatal}" == "1" ]]; then
350 local ABI enabled_PYTHON_ABIS
351 for ABI in ${PYTHON_ABIS}; do
352 [[ "${ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+=" ${ABI}"
353 done
354 export PYTHON_ABIS="${enabled_PYTHON_ABIS# }"
355 if [[ "${quiet}" == "0" ]]; then 1057 if [[ "${quiet}" == "0" ]]; then
356 ewarn "${RED}${failure_message}${NORMAL}" 1058 ewarn "${failure_message}"
1059 fi
1060 elif [[ "${final_ABI}" == "0" ]] && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then
1061 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then
1062 local enabled_PYTHON_ABIS= other_PYTHON_ABI
1063 for other_PYTHON_ABI in ${PYTHON_ABIS}; do
1064 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}"
1065 done
1066 export PYTHON_ABIS="${enabled_PYTHON_ABIS}"
1067 fi
1068 if [[ "${quiet}" == "0" ]]; then
1069 ewarn "${failure_message}"
1070 fi
1071 if [[ -z "${PYTHON_ABIS}" ]]; then
1072 die "${function}() function failed with all enabled Python ABIs"
357 fi 1073 fi
358 else 1074 else
359 die "${failure_message}" 1075 die "${failure_message}"
360 fi 1076 fi
361 fi 1077 fi
362 1078
1079 # Ensure that directory stack has not been decreased.
1080 if [[ "$(dirs -p | wc -l)" -lt "${previous_directory_stack_length}" ]]; then
1081 die "Directory stack decreased illegally"
1082 fi
1083
1084 # Avoid side effects of earlier returning from the specified function.
1085 while [[ "$(dirs -p | wc -l)" -gt "${previous_directory_stack_length}" ]]; do
1086 popd > /dev/null || die "popd failed"
1087 done
1088
1089 # Ensure that the bottom part of directory stack has not been changed. Restore
1090 # previous directory (from before running of the specified function) before
1091 # comparison of directory stacks to avoid mismatch of directory stacks after
1092 # potential using of 'cd' to change current directory. Restoration of previous
1093 # directory allows to safely use 'cd' to change current directory in the
1094 # specified function without changing it back to original directory.
1095 cd "${previous_directory}"
1096 if [[ "$(dirs -p)" != "${previous_directory_stack}" ]]; then
1097 die "Directory stack changed illegally"
1098 fi
1099
363 if [[ "${separate_build_dirs}" == "1" ]]; then 1100 if [[ "${separate_build_dirs}" == "1" ]]; then
364 popd > /dev/null || die "popd failed" 1101 popd > /dev/null || die "popd failed"
365 fi 1102 fi
366 unset BUILDDIR 1103 unset BUILDDIR
367 done 1104 done
369 if [[ "${default_function}" == "1" ]]; then 1106 if [[ "${default_function}" == "1" ]]; then
370 unset -f python_default_function 1107 unset -f python_default_function
371 fi 1108 fi
372} 1109}
373 1110
1111# @FUNCTION: python_copy_sources
1112# @USAGE: <directory="${S}"> [directory]
1113# @DESCRIPTION:
1114# Copy unpacked sources of current package to separate build directory for each Python ABI.
1115python_copy_sources() {
1116 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1117 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1118 fi
374 1119
1120 _python_check_python_pkg_setup_execution
1121
1122 local dir dirs=() PYTHON_ABI
1123
1124 if [[ "$#" -eq 0 ]]; then
1125 if [[ "${WORKDIR}" == "${S}" ]]; then
1126 die "${FUNCNAME}() cannot be used with current value of S variable"
1127 fi
1128 dirs=("${S%/}")
1129 else
1130 dirs=("$@")
1131 fi
1132
1133 _python_calculate_PYTHON_ABIS
1134 for PYTHON_ABI in ${PYTHON_ABIS}; do
1135 for dir in "${dirs[@]}"; do
1136 cp -pr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed"
1137 done
1138 done
1139}
1140
1141# @FUNCTION: python_generate_wrapper_scripts
1142# @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files]
1143# @DESCRIPTION:
1144# Generate wrapper scripts. Existing files are overwritten only with --force option.
1145# If --respect-EPYTHON option is specified, then generated wrapper scripts will
1146# respect EPYTHON variable at run time.
1147#
1148# This function can be used only in src_install() phase.
1149python_generate_wrapper_scripts() {
1150 if [[ "${EBUILD_PHASE}" != "install" ]]; then
1151 die "${FUNCNAME}() can be used only in src_install() phase"
1152 fi
1153
1154 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1155 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1156 fi
1157
1158 _python_check_python_pkg_setup_execution
1159 _python_initialize_prefix_variables
1160
1161 local eselect_python_option file force="0" quiet="0" PYTHON_ABI PYTHON_ABIS_list python2_enabled="0" python3_enabled="0" respect_EPYTHON="0"
1162
1163 while (($#)); do
1164 case "$1" in
1165 -E|--respect-EPYTHON)
1166 respect_EPYTHON="1"
1167 ;;
1168 -f|--force)
1169 force="1"
1170 ;;
1171 -q|--quiet)
1172 quiet="1"
1173 ;;
1174 --)
1175 shift
1176 break
1177 ;;
1178 -*)
1179 die "${FUNCNAME}(): Unrecognized option '$1'"
1180 ;;
1181 *)
1182 break
1183 ;;
1184 esac
1185 shift
1186 done
1187
1188 if [[ "$#" -eq 0 ]]; then
1189 die "${FUNCNAME}(): Missing arguments"
1190 fi
1191
1192 _python_calculate_PYTHON_ABIS
1193 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
1194 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
1195 python2_enabled="1"
1196 fi
1197 done
1198 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
1199 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
1200 python3_enabled="1"
1201 fi
1202 done
1203
1204 if [[ "${python2_enabled}" == "1" && "${python3_enabled}" == "1" ]]; then
1205 eselect_python_option=
1206 elif [[ "${python2_enabled}" == "1" && "${python3_enabled}" == "0" ]]; then
1207 eselect_python_option="--python2"
1208 elif [[ "${python2_enabled}" == "0" && "${python3_enabled}" == "1" ]]; then
1209 eselect_python_option="--python3"
1210 else
1211 die "${FUNCNAME}(): Unsupported environment"
1212 fi
1213
1214 PYTHON_ABIS_list="$("$(PYTHON -f)" -c "print(', '.join('\"%s\"' % x for x in reversed('${PYTHON_ABIS}'.split())))")"
1215
1216 for file in "$@"; do
1217 if [[ -f "${file}" && "${force}" == "0" ]]; then
1218 die "${FUNCNAME}(): '${file}' already exists"
1219 fi
1220
1221 if [[ "${quiet}" == "0" ]]; then
1222 einfo "Generating '${file#${ED%/}}' wrapper script"
1223 fi
1224
1225 cat << EOF > "${file}"
1226#!/usr/bin/env python
1227# Gentoo '${file##*/}' wrapper script generated by python_generate_wrapper_scripts()
1228
1229import os
1230import re
1231import subprocess
1232import sys
1233
1234cpython_re = re.compile(r"^python(\d+\.\d+)$")
1235jython_re = re.compile(r"^jython(\d+\.\d+)$")
1236python_shebang_re = re.compile(r"^#! *(${EPREFIX}/usr/bin/python|(${EPREFIX})?/usr/bin/env +(${EPREFIX}/usr/bin/)?python)")
1237python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
1238
1239def get_PYTHON_ABI(EPYTHON):
1240 cpython_matched = cpython_re.match(EPYTHON)
1241 jython_matched = jython_re.match(EPYTHON)
1242 if cpython_matched is not None:
1243 PYTHON_ABI = cpython_matched.group(1)
1244 elif jython_matched is not None:
1245 PYTHON_ABI = jython_matched.group(1) + "-jython"
1246 else:
1247 PYTHON_ABI = None
1248 return PYTHON_ABI
1249
1250EOF
1251 if [[ "$?" != "0" ]]; then
1252 die "${FUNCNAME}(): Generation of '$1' failed"
1253 fi
1254 if [[ "${respect_EPYTHON}" == "1" ]]; then
1255 cat << EOF >> "${file}"
1256EPYTHON = os.environ.get("EPYTHON")
1257if EPYTHON:
1258 PYTHON_ABI = get_PYTHON_ABI(EPYTHON)
1259 if PYTHON_ABI is None:
1260 sys.stderr.write("EPYTHON variable has unrecognized value '%s'\n" % EPYTHON)
1261 sys.exit(1)
1262else:
1263 try:
1264 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE)
1265 if eselect_process.wait() != 0:
1266 raise ValueError
1267 except (OSError, ValueError):
1268 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n")
1269 sys.exit(1)
1270
1271 EPYTHON = eselect_process.stdout.read()
1272 if not isinstance(EPYTHON, str):
1273 # Python 3
1274 EPYTHON = EPYTHON.decode()
1275 EPYTHON = EPYTHON.rstrip("\n")
1276
1277 PYTHON_ABI = get_PYTHON_ABI(EPYTHON)
1278 if PYTHON_ABI is None:
1279 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON)
1280 sys.exit(1)
1281
1282wrapper_script_path = os.path.realpath(sys.argv[0])
1283target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1284if not os.path.exists(target_executable_path):
1285 sys.stderr.write("'%s' does not exist\n" % target_executable_path)
1286 sys.exit(1)
1287EOF
1288 if [[ "$?" != "0" ]]; then
1289 die "${FUNCNAME}(): Generation of '$1' failed"
1290 fi
1291 else
1292 cat << EOF >> "${file}"
1293try:
1294 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE)
1295 if eselect_process.wait() != 0:
1296 raise ValueError
1297except (OSError, ValueError):
1298 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n")
1299 sys.exit(1)
1300
1301EPYTHON = eselect_process.stdout.read()
1302if not isinstance(EPYTHON, str):
1303 # Python 3
1304 EPYTHON = EPYTHON.decode()
1305EPYTHON = EPYTHON.rstrip("\n")
1306
1307PYTHON_ABI = get_PYTHON_ABI(EPYTHON)
1308if PYTHON_ABI is None:
1309 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON)
1310 sys.exit(1)
1311
1312wrapper_script_path = os.path.realpath(sys.argv[0])
1313for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]:
1314 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1315 if os.path.exists(target_executable_path):
1316 break
1317else:
1318 sys.stderr.write("No target script exists for '%s'\n" % wrapper_script_path)
1319 sys.exit(1)
1320EOF
1321 if [[ "$?" != "0" ]]; then
1322 die "${FUNCNAME}(): Generation of '$1' failed"
1323 fi
1324 fi
1325 cat << EOF >> "${file}"
1326
1327target_executable = open(target_executable_path, "rb")
1328target_executable_first_line = target_executable.readline()
1329if not isinstance(target_executable_first_line, str):
1330 # Python 3
1331 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace")
1332
1333python_shebang_matched = python_shebang_re.match(target_executable_first_line)
1334target_executable.close()
1335
1336if python_shebang_matched is not None:
1337 try:
1338 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % EPYTHON
1339 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1"
1340 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE)
1341 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
1342 if python_verification_process.wait() != 0:
1343 raise ValueError
1344
1345 python_verification_output = python_verification_process.stdout.read()
1346 if not isinstance(python_verification_output, str):
1347 # Python 3
1348 python_verification_output = python_verification_output.decode()
1349
1350 if not python_verification_output_re.match(python_verification_output):
1351 raise ValueError
1352
1353 if cpython_re.match(EPYTHON) is not None:
1354 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0])
1355 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
1356 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
1357
1358 if hasattr(os, "execv"):
1359 os.execv(python_interpreter_path, [python_interpreter_path] + sys.argv)
1360 else:
1361 sys.exit(subprocess.Popen([python_interpreter_path] + sys.argv).wait())
1362 except (KeyboardInterrupt, SystemExit):
1363 raise
1364 except:
1365 pass
1366 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"):
1367 if variable in os.environ:
1368 del os.environ[variable]
1369
1370if hasattr(os, "execv"):
1371 os.execv(target_executable_path, sys.argv)
1372else:
1373 sys.exit(subprocess.Popen([target_executable_path] + sys.argv[1:]).wait())
1374EOF
1375 if [[ "$?" != "0" ]]; then
1376 die "${FUNCNAME}(): Generation of '$1' failed"
1377 fi
1378 fperms +x "${file#${ED%/}}" || die "fperms '${file}' failed"
1379 done
1380}
1381
1382# @ECLASS-VARIABLE: PYTHON_VERSIONED_SCRIPTS
1383# @DESCRIPTION:
1384# Array of regular expressions of paths to versioned Python scripts.
1385# Python scripts in /usr/bin and /usr/sbin are versioned by default.
1386
1387# @ECLASS-VARIABLE: PYTHON_VERSIONED_EXECUTABLES
1388# @DESCRIPTION:
1389# Array of regular expressions of paths to versioned executables (including Python scripts).
1390
1391# @ECLASS-VARIABLE: PYTHON_NONVERSIONED_EXECUTABLES
1392# @DESCRIPTION:
1393# Array of regular expressions of paths to nonversioned executables (including Python scripts).
1394
1395# @FUNCTION: python_merge_intermediate_installation_images
1396# @USAGE: [-q|--quiet] [--] <intermediate_installation_images_directory>
1397# @DESCRIPTION:
1398# Merge intermediate installation images into installation image.
1399#
1400# This function can be used only in src_install() phase.
1401python_merge_intermediate_installation_images() {
1402 if [[ "${EBUILD_PHASE}" != "install" ]]; then
1403 die "${FUNCNAME}() can be used only in src_install() phase"
1404 fi
1405
1406 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1407 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1408 fi
1409
1410 _python_check_python_pkg_setup_execution
1411 _python_initialize_prefix_variables
1412
1413 local b file files=() intermediate_installation_images_directory PYTHON_ABI quiet="0" regex shebang version_executable wrapper_scripts=() wrapper_scripts_set=()
1414
1415 while (($#)); do
1416 case "$1" in
1417 -q|--quiet)
1418 quiet="1"
1419 ;;
1420 --)
1421 shift
1422 break
1423 ;;
1424 -*)
1425 die "${FUNCNAME}(): Unrecognized option '$1'"
1426 ;;
1427 *)
1428 break
1429 ;;
1430 esac
1431 shift
1432 done
1433
1434 if [[ "$#" -ne 1 ]]; then
1435 die "${FUNCNAME}() requires 1 argument"
1436 fi
1437
1438 intermediate_installation_images_directory="$1"
1439
1440 if [[ ! -d "${intermediate_installation_images_directory}" ]]; then
1441 die "${FUNCNAME}(): Intermediate installation images directory '${intermediate_installation_images_directory}' does not exist"
1442 fi
1443
1444 _python_calculate_PYTHON_ABIS
1445 if [[ "$(PYTHON -f --ABI)" == 3.* ]]; then
1446 b="b"
1447 fi
1448
1449 while read -d $'\0' -r file; do
1450 files+=("${file}")
1451 done < <("$(PYTHON -f)" -c \
1452"import os
1453import sys
1454
1455if hasattr(sys.stdout, 'buffer'):
1456 # Python 3
1457 stdout = sys.stdout.buffer
1458else:
1459 # Python 2
1460 stdout = sys.stdout
1461
1462files_set = set()
1463
1464os.chdir(${b}'${intermediate_installation_images_directory}')
1465
1466for PYTHON_ABI in ${b}'${PYTHON_ABIS}'.split():
1467 for root, dirs, files in os.walk(PYTHON_ABI + ${b}'${EPREFIX}'):
1468 root = root[len(PYTHON_ABI + ${b}'${EPREFIX}')+1:]
1469 files_set.update(root + ${b}'/' + file for file in files)
1470
1471for file in sorted(files_set):
1472 stdout.write(file)
1473 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of files in intermediate installation images")
1474
1475 for PYTHON_ABI in ${PYTHON_ABIS}; do
1476 if [[ ! -d "${intermediate_installation_images_directory}/${PYTHON_ABI}" ]]; then
1477 die "${FUNCNAME}(): Intermediate installation image for Python ABI '${PYTHON_ABI}' does not exist"
1478 fi
1479
1480 pushd "${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}" > /dev/null || die "pushd failed"
1481
1482 for file in "${files[@]}"; do
1483 version_executable="0"
1484 for regex in "/usr/bin/.*" "/usr/sbin/.*" "${PYTHON_VERSIONED_SCRIPTS[@]}"; do
1485 if [[ "/${file}" =~ ^${regex}$ ]]; then
1486 version_executable="1"
1487 break
1488 fi
1489 done
1490 for regex in "${PYTHON_VERSIONED_EXECUTABLES[@]}"; do
1491 if [[ "/${file}" =~ ^${regex}$ ]]; then
1492 version_executable="2"
1493 break
1494 fi
1495 done
1496 if [[ "${version_executable}" != "0" ]]; then
1497 for regex in "${PYTHON_NONVERSIONED_EXECUTABLES[@]}"; do
1498 if [[ "/${file}" =~ ^${regex}$ ]]; then
1499 version_executable="0"
1500 break
1501 fi
1502 done
1503 fi
1504
1505 [[ "${version_executable}" == "0" || ! -x "${file}" ]] && continue
1506
1507 shebang="$(head -n1 "${file}")" || die "Extraction of shebang from '${file}' failed"
1508
1509 if [[ "${version_executable}" == "2" ]]; then
1510 wrapper_scripts+=("${ED}${file}")
1511 elif [[ "${version_executable}" == "1" ]]; then
1512 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}([[:digit:]]+(\.[[:digit:]]+)?)?($|[[:space:]]+) ]]; then
1513 wrapper_scripts+=("${ED}${file}")
1514 else
1515 version_executable="0"
1516 fi
1517 fi
1518
1519 [[ "${version_executable}" == "0" ]] && continue
1520
1521 if [[ -e "${file}-${PYTHON_ABI}" ]]; then
1522 die "${FUNCNAME}(): '${EPREFIX}/${file}-${PYTHON_ABI}' already exists"
1523 fi
1524
1525 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed"
1526
1527 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}[[:digit:]]*($|[[:space:]]+) ]]; then
1528 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${file}-${PYTHON_ABI}"
1529 fi
1530 done
1531
1532 popd > /dev/null || die "popd failed"
1533
1534 if ROOT="/" has_version sys-apps/coreutils; then
1535 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1536 else
1537 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1538 fi
1539 done
1540
1541 rm -fr "${intermediate_installation_images_directory}"
1542
1543 if [[ "${#wrapper_scripts[@]}" -ge 1 ]]; then
1544 rm -f "${T}/python_wrapper_scripts"
1545
1546 for file in "${wrapper_scripts[@]}"; do
1547 echo -n "${file}" >> "${T}/python_wrapper_scripts"
1548 echo -en "\x00" >> "${T}/python_wrapper_scripts"
1549 done
1550
1551 while read -d $'\0' -r file; do
1552 wrapper_scripts_set+=("${file}")
1553 done < <("$(PYTHON -f)" -c \
1554"import sys
1555
1556if hasattr(sys.stdout, 'buffer'):
1557 # Python 3
1558 stdout = sys.stdout.buffer
1559else:
1560 # Python 2
1561 stdout = sys.stdout
1562
1563files = set(open('${T}/python_wrapper_scripts', 'rb').read().rstrip(${b}'\x00').split(${b}'\x00'))
1564
1565for file in sorted(files):
1566 stdout.write(file)
1567 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts")
1568
1569 python_generate_wrapper_scripts $([[ "${quiet}" == "1" ]] && echo --quiet) "${wrapper_scripts_set[@]}"
1570 fi
1571}
1572
1573# ================================================================================================
1574# ========= FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ==========
1575# ================================================================================================
1576
1577unset EPYTHON PYTHON_ABI
1578
1579# @FUNCTION: python_set_active_version
1580# @USAGE: <Python_ABI|2|3>
1581# @DESCRIPTION:
1582# Set locally active version of Python.
1583# If Python_ABI argument is specified, then version of Python corresponding to Python_ABI is used.
1584# If 2 argument is specified, then active version of CPython 2 is used.
1585# If 3 argument is specified, then active version of CPython 3 is used.
1586#
1587# This function can be used only in pkg_setup() phase.
1588python_set_active_version() {
1589 if [[ "${EBUILD_PHASE}" != "setup" ]]; then
1590 die "${FUNCNAME}() can be used only in pkg_setup() phase"
1591 fi
1592
1593 if _python_package_supporting_installation_for_multiple_python_abis; then
1594 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1595 fi
1596
1597 if [[ "$#" -ne 1 ]]; then
1598 die "${FUNCNAME}() requires 1 argument"
1599 fi
1600
1601 _python_initial_sanity_checks
1602
1603 if [[ -z "${PYTHON_ABI}" ]]; then
1604 if [[ -n "$(_python_get_implementation --ignore-invalid "$1")" ]]; then
1605 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses,
1606 # so it does not need to be exported to subprocesses.
1607 PYTHON_ABI="$1"
1608 if ! _python_implementation && ! has_version "$(python_get_implementational_package)"; then
1609 die "${FUNCNAME}(): '$(python_get_implementational_package)' is not installed"
1610 fi
1611 export EPYTHON="$(PYTHON "$1")"
1612 elif [[ "$1" == "2" ]]; then
1613 if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then
1614 die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed"
1615 fi
1616 export EPYTHON="$(PYTHON -2)"
1617 PYTHON_ABI="${EPYTHON#python}"
1618 PYTHON_ABI="${PYTHON_ABI%%-*}"
1619 elif [[ "$1" == "3" ]]; then
1620 if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then
1621 die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed"
1622 fi
1623 export EPYTHON="$(PYTHON -3)"
1624 PYTHON_ABI="${EPYTHON#python}"
1625 PYTHON_ABI="${PYTHON_ABI%%-*}"
1626 else
1627 die "${FUNCNAME}(): Unrecognized argument '$1'"
1628 fi
1629 fi
1630
1631 _python_final_sanity_checks
1632
1633 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable.
1634 PYTHON_REQUESTED_ACTIVE_VERSION="$1"
1635}
1636
1637# @FUNCTION: python_need_rebuild
1638# @DESCRIPTION: Mark current package for rebuilding by python-updater after
1639# switching of active version of Python.
1640python_need_rebuild() {
1641 if _python_package_supporting_installation_for_multiple_python_abis; then
1642 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1643 fi
1644
1645 _python_check_python_pkg_setup_execution
1646
1647 if [[ "$#" -ne 0 ]]; then
1648 die "${FUNCNAME}() does not accept arguments"
1649 fi
1650
1651 export PYTHON_NEED_REBUILD="$(PYTHON --ABI)"
1652}
1653
1654# ================================================================================================
1655# ======================================= GETTER FUNCTIONS =======================================
1656# ================================================================================================
1657
1658_PYTHON_ABI_EXTRACTION_COMMAND='import platform
1659import sys
1660sys.stdout.write(".".join(str(x) for x in sys.version_info[:2]))
1661if platform.system()[:4] == "Java":
1662 sys.stdout.write("-jython")'
1663
1664_python_get_implementation() {
1665 local ignore_invalid="0"
1666
1667 while (($#)); do
1668 case "$1" in
1669 --ignore-invalid)
1670 ignore_invalid="1"
1671 ;;
1672 --)
1673 shift
1674 break
1675 ;;
1676 -*)
1677 die "${FUNCNAME}(): Unrecognized option '$1'"
1678 ;;
1679 *)
1680 break
1681 ;;
1682 esac
1683 shift
1684 done
1685
1686 if [[ "$#" -ne 1 ]]; then
1687 die "${FUNCNAME}() requires 1 argument"
1688 fi
1689
1690 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
1691 echo "CPython"
1692 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
1693 echo "Jython"
1694 else
1695 if [[ "${ignore_invalid}" == "0" ]]; then
1696 die "${FUNCNAME}(): Unrecognized Python ABI '$1'"
1697 fi
1698 fi
1699}
1700
1701# @FUNCTION: PYTHON
1702# @USAGE: [-2] [-3] [--ABI] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}">
1703# @DESCRIPTION:
1704# Print filename of Python interpreter for specified Python ABI. If Python_ABI argument
1705# is ommitted, then PYTHON_ABI environment variable must be set and is used.
1706# If -2 option is specified, then active version of CPython 2 is used.
1707# If -3 option is specified, then active version of CPython 3 is used.
1708# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1709# -2, -3 and --final-ABI options and Python_ABI argument cannot be specified simultaneously.
1710# If --ABI option is specified, then only specified Python ABI is printed instead of
1711# filename of Python interpreter.
1712# If --absolute-path option is specified, then absolute path to Python interpreter is printed.
1713# --ABI and --absolute-path options cannot be specified simultaneously.
1714PYTHON() {
1715 _python_check_python_pkg_setup_execution
1716
1717 local ABI_output="0" absolute_path_output="0" final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" python_interpreter python2="0" python3="0"
1718
1719 while (($#)); do
1720 case "$1" in
1721 -2)
1722 python2="1"
1723 ;;
1724 -3)
1725 python3="1"
1726 ;;
1727 --ABI)
1728 ABI_output="1"
1729 ;;
1730 -a|--absolute-path)
1731 absolute_path_output="1"
1732 ;;
1733 -f|--final-ABI)
1734 final_ABI="1"
1735 ;;
1736 --)
1737 shift
1738 break
1739 ;;
1740 -*)
1741 die "${FUNCNAME}(): Unrecognized option '$1'"
1742 ;;
1743 *)
1744 break
1745 ;;
1746 esac
1747 shift
1748 done
1749
1750 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then
1751 die "${FUNCNAME}(): '--ABI' and '--absolute-path' options cannot be specified simultaneously"
1752 fi
1753
1754 if [[ "$((${python2} + ${python3} + ${final_ABI}))" -gt 1 ]]; then
1755 die "${FUNCNAME}(): '-2', '-3' or '--final-ABI' options cannot be specified simultaneously"
1756 fi
1757
1758 if [[ "$#" -eq 0 ]]; then
1759 if [[ "${final_ABI}" == "1" ]]; then
1760 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1761 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1762 fi
1763 _python_calculate_PYTHON_ABIS
1764 PYTHON_ABI="${PYTHON_ABIS##* }"
1765 elif [[ "${python2}" == "1" ]]; then
1766 PYTHON_ABI="$(eselect python show --python2 --ABI)"
1767 if [[ -z "${PYTHON_ABI}" ]]; then
1768 die "${FUNCNAME}(): Active version of CPython 2 not set"
1769 elif [[ "${PYTHON_ABI}" != "2."* ]]; then
1770 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`"
1771 fi
1772 elif [[ "${python3}" == "1" ]]; then
1773 PYTHON_ABI="$(eselect python show --python3 --ABI)"
1774 if [[ -z "${PYTHON_ABI}" ]]; then
1775 die "${FUNCNAME}(): Active version of CPython 3 not set"
1776 elif [[ "${PYTHON_ABI}" != "3."* ]]; then
1777 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`"
1778 fi
1779 elif _python_package_supporting_installation_for_multiple_python_abis; then
1780 if ! _python_abi-specific_local_scope; then
1781 die "${FUNCNAME}() should be used in ABI-specific local scope"
1782 fi
1783 else
1784 PYTHON_ABI="$("${EPREFIX}/usr/bin/python" -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")"
1785 if [[ -z "${PYTHON_ABI}" ]]; then
1786 die "${FUNCNAME}(): Failure of extraction of locally active version of Python"
1787 fi
1788 fi
1789 elif [[ "$#" -eq 1 ]]; then
1790 if [[ "${final_ABI}" == "1" ]]; then
1791 die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously"
1792 fi
1793 if [[ "${python2}" == "1" ]]; then
1794 die "${FUNCNAME}(): '-2' option and Python ABI cannot be specified simultaneously"
1795 fi
1796 if [[ "${python3}" == "1" ]]; then
1797 die "${FUNCNAME}(): '-3' option and Python ABI cannot be specified simultaneously"
1798 fi
1799 PYTHON_ABI="$1"
1800 else
1801 die "${FUNCNAME}(): Invalid usage"
1802 fi
1803
1804 if [[ "${ABI_output}" == "1" ]]; then
1805 echo -n "${PYTHON_ABI}"
1806 return
1807 else
1808 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1809 python_interpreter="python${PYTHON_ABI}"
1810 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1811 python_interpreter="jython${PYTHON_ABI%-jython}"
1812 fi
1813
1814 if [[ "${absolute_path_output}" == "1" ]]; then
1815 echo -n "${EPREFIX}/usr/bin/${python_interpreter}"
1816 else
1817 echo -n "${python_interpreter}"
1818 fi
1819 fi
1820
1821 if [[ -n "${ABI}" && "${ABI}" != "${DEFAULT_ABI}" && "${DEFAULT_ABI}" != "default" ]]; then
1822 echo -n "-${ABI}"
1823 fi
1824}
1825
1826# @FUNCTION: python_get_implementation
1827# @USAGE: [-f|--final-ABI]
1828# @DESCRIPTION:
1829# Print name of Python implementation.
1830# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1831python_get_implementation() {
1832 _python_check_python_pkg_setup_execution
1833
1834 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1835
1836 while (($#)); do
1837 case "$1" in
1838 -f|--final-ABI)
1839 final_ABI="1"
1840 ;;
1841 -*)
1842 die "${FUNCNAME}(): Unrecognized option '$1'"
1843 ;;
1844 *)
1845 die "${FUNCNAME}(): Invalid usage"
1846 ;;
1847 esac
1848 shift
1849 done
1850
1851 if [[ "${final_ABI}" == "1" ]]; then
1852 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1853 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1854 fi
1855 PYTHON_ABI="$(PYTHON -f --ABI)"
1856 else
1857 if _python_package_supporting_installation_for_multiple_python_abis; then
1858 if ! _python_abi-specific_local_scope; then
1859 die "${FUNCNAME}() should be used in ABI-specific local scope"
1860 fi
1861 else
1862 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1863 fi
1864 fi
1865
1866 echo "$(_python_get_implementation "${PYTHON_ABI}")"
1867}
1868
1869# @FUNCTION: python_get_implementational_package
1870# @USAGE: [-f|--final-ABI]
1871# @DESCRIPTION:
1872# Print category, name and slot of package providing Python implementation.
1873# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1874python_get_implementational_package() {
1875 _python_check_python_pkg_setup_execution
1876
1877 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1878
1879 while (($#)); do
1880 case "$1" in
1881 -f|--final-ABI)
1882 final_ABI="1"
1883 ;;
1884 -*)
1885 die "${FUNCNAME}(): Unrecognized option '$1'"
1886 ;;
1887 *)
1888 die "${FUNCNAME}(): Invalid usage"
1889 ;;
1890 esac
1891 shift
1892 done
1893
1894 if [[ "${final_ABI}" == "1" ]]; then
1895 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1896 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1897 fi
1898 PYTHON_ABI="$(PYTHON -f --ABI)"
1899 else
1900 if _python_package_supporting_installation_for_multiple_python_abis; then
1901 if ! _python_abi-specific_local_scope; then
1902 die "${FUNCNAME}() should be used in ABI-specific local scope"
1903 fi
1904 else
1905 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1906 fi
1907 fi
1908
1909 if [[ "${EAPI:-0}" == "0" ]]; then
1910 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1911 echo "=dev-lang/python-${PYTHON_ABI}*"
1912 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1913 echo "=dev-java/jython-${PYTHON_ABI%-jython}*"
1914 fi
1915 else
1916 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1917 echo "dev-lang/python:${PYTHON_ABI}"
1918 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1919 echo "dev-java/jython:${PYTHON_ABI%-jython}"
1920 fi
1921 fi
1922}
1923
1924# @FUNCTION: python_get_includedir
1925# @USAGE: [-b|--base-path] [-f|--final-ABI]
1926# @DESCRIPTION:
1927# Print path to Python include directory.
1928# If --base-path option is specified, then path not prefixed with "/" is printed.
1929# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1930python_get_includedir() {
1931 _python_check_python_pkg_setup_execution
1932
1933 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
1934
1935 while (($#)); do
1936 case "$1" in
1937 -b|--base-path)
1938 base_path="1"
1939 ;;
1940 -f|--final-ABI)
1941 final_ABI="1"
1942 ;;
1943 -*)
1944 die "${FUNCNAME}(): Unrecognized option '$1'"
1945 ;;
1946 *)
1947 die "${FUNCNAME}(): Invalid usage"
1948 ;;
1949 esac
1950 shift
1951 done
1952
1953 if [[ "${base_path}" == "0" ]]; then
1954 prefix="/"
1955 fi
1956
1957 if [[ "${final_ABI}" == "1" ]]; then
1958 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1959 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1960 fi
1961 PYTHON_ABI="$(PYTHON -f --ABI)"
1962 else
1963 if _python_package_supporting_installation_for_multiple_python_abis; then
1964 if ! _python_abi-specific_local_scope; then
1965 die "${FUNCNAME}() should be used in ABI-specific local scope"
1966 fi
1967 else
1968 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1969 fi
1970 fi
1971
1972 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1973 echo "${prefix}usr/include/python${PYTHON_ABI}"
1974 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1975 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include"
1976 fi
1977}
1978
1979# @FUNCTION: python_get_libdir
1980# @USAGE: [-b|--base-path] [-f|--final-ABI]
1981# @DESCRIPTION:
1982# Print path to Python library directory.
1983# If --base-path option is specified, then path not prefixed with "/" is printed.
1984# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1985python_get_libdir() {
1986 _python_check_python_pkg_setup_execution
1987
1988 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
1989
1990 while (($#)); do
1991 case "$1" in
1992 -b|--base-path)
1993 base_path="1"
1994 ;;
1995 -f|--final-ABI)
1996 final_ABI="1"
1997 ;;
1998 -*)
1999 die "${FUNCNAME}(): Unrecognized option '$1'"
2000 ;;
2001 *)
2002 die "${FUNCNAME}(): Invalid usage"
2003 ;;
2004 esac
2005 shift
2006 done
2007
2008 if [[ "${base_path}" == "0" ]]; then
2009 prefix="/"
2010 fi
2011
2012 if [[ "${final_ABI}" == "1" ]]; then
2013 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2014 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2015 fi
2016 PYTHON_ABI="$(PYTHON -f --ABI)"
2017 else
2018 if _python_package_supporting_installation_for_multiple_python_abis; then
2019 if ! _python_abi-specific_local_scope; then
2020 die "${FUNCNAME}() should be used in ABI-specific local scope"
2021 fi
2022 else
2023 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2024 fi
2025 fi
2026
2027 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2028 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}"
2029 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2030 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib"
2031 fi
2032}
2033
2034# @FUNCTION: python_get_sitedir
2035# @USAGE: [-b|--base-path] [-f|--final-ABI]
2036# @DESCRIPTION:
2037# Print path to Python site-packages directory.
2038# If --base-path option is specified, then path not prefixed with "/" is printed.
2039# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2040python_get_sitedir() {
2041 _python_check_python_pkg_setup_execution
2042
2043 local final_ABI="0" options=()
2044
2045 while (($#)); do
2046 case "$1" in
2047 -b|--base-path)
2048 options+=("$1")
2049 ;;
2050 -f|--final-ABI)
2051 final_ABI="1"
2052 options+=("$1")
2053 ;;
2054 -*)
2055 die "${FUNCNAME}(): Unrecognized option '$1'"
2056 ;;
2057 *)
2058 die "${FUNCNAME}(): Invalid usage"
2059 ;;
2060 esac
2061 shift
2062 done
2063
2064 if [[ "${final_ABI}" == "1" ]]; then
2065 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2066 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2067 fi
2068 else
2069 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then
2070 die "${FUNCNAME}() should be used in ABI-specific local scope"
2071 fi
2072 fi
2073
2074 echo "$(python_get_libdir "${options[@]}")/site-packages"
2075}
2076
2077# @FUNCTION: python_get_library
2078# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option]
2079# @DESCRIPTION:
2080# Print path to Python library.
2081# If --base-path option is specified, then path not prefixed with "/" is printed.
2082# If --linker-option is specified, then "-l${library}" linker option is printed.
2083# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2084python_get_library() {
2085 _python_check_python_pkg_setup_execution
2086
2087 local base_path="0" final_ABI="0" linker_option="0" prefix PYTHON_ABI="${PYTHON_ABI}"
2088
2089 while (($#)); do
2090 case "$1" in
2091 -b|--base-path)
2092 base_path="1"
2093 ;;
2094 -f|--final-ABI)
2095 final_ABI="1"
2096 ;;
2097 -l|--linker-option)
2098 linker_option="1"
2099 ;;
2100 -*)
2101 die "${FUNCNAME}(): Unrecognized option '$1'"
2102 ;;
2103 *)
2104 die "${FUNCNAME}(): Invalid usage"
2105 ;;
2106 esac
2107 shift
2108 done
2109
2110 if [[ "${base_path}" == "0" ]]; then
2111 prefix="/"
2112 fi
2113
2114 if [[ "${base_path}" == "1" && "${linker_option}" == "1" ]]; then
2115 die "${FUNCNAME}(): '--base-path' and '--linker-option' options cannot be specified simultaneously"
2116 fi
2117
2118 if [[ "${final_ABI}" == "1" ]]; then
2119 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2120 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2121 fi
2122 PYTHON_ABI="$(PYTHON -f --ABI)"
2123 else
2124 if _python_package_supporting_installation_for_multiple_python_abis; then
2125 if ! _python_abi-specific_local_scope; then
2126 die "${FUNCNAME}() should be used in ABI-specific local scope"
2127 fi
2128 else
2129 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2130 fi
2131 fi
2132
2133 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2134 if [[ "${linker_option}" == "1" ]]; then
2135 echo "-lpython${PYTHON_ABI}"
2136 else
2137 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)"
2138 fi
2139 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2140 die "${FUNCNAME}(): Jython does not have shared library"
2141 fi
2142}
2143
2144# @FUNCTION: python_get_version
2145# @USAGE: [-f|--final-ABI] [--full] [--major] [--minor] [--micro]
2146# @DESCRIPTION:
2147# Print Python version.
2148# --full, --major, --minor and --micro options cannot be specified simultaneously.
2149# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
2150# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2151python_get_version() {
2152 _python_check_python_pkg_setup_execution
2153
2154 local final_ABI="0" full="0" major="0" minor="0" micro="0" python_command
2155
2156 while (($#)); do
2157 case "$1" in
2158 -f|--final-ABI)
2159 final_ABI="1"
2160 ;;
2161 --full)
2162 full="1"
2163 ;;
2164 --major)
2165 major="1"
2166 ;;
2167 --minor)
2168 minor="1"
2169 ;;
2170 --micro)
2171 micro="1"
2172 ;;
2173 -*)
2174 die "${FUNCNAME}(): Unrecognized option '$1'"
2175 ;;
2176 *)
2177 die "${FUNCNAME}(): Invalid usage"
2178 ;;
2179 esac
2180 shift
2181 done
2182
2183 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
2184 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
2185 fi
2186
2187 if [[ "${full}" == "1" ]]; then
2188 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:3]))"
2189 elif [[ "${major}" == "1" ]]; then
2190 python_command="from sys import version_info; print(version_info[0])"
2191 elif [[ "${minor}" == "1" ]]; then
2192 python_command="from sys import version_info; print(version_info[1])"
2193 elif [[ "${micro}" == "1" ]]; then
2194 python_command="from sys import version_info; print(version_info[2])"
2195 else
2196 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
2197 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2198 echo "${PYTHON_ABI}"
2199 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2200 echo "${PYTHON_ABI%-jython}"
2201 fi
2202 return
2203 fi
2204 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
2205 fi
2206
2207 if [[ "${final_ABI}" == "1" ]]; then
2208 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2209 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2210 fi
2211 "$(PYTHON -f)" -c "${python_command}"
2212 else
2213 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then
2214 die "${FUNCNAME}() should be used in ABI-specific local scope"
2215 fi
2216 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}"
2217 fi
2218}
2219
2220# ================================================================================================
2221# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================
2222# ================================================================================================
2223
375# @ECLASS-VARIABLE: PYTHON_USE_WITH 2224# @ECLASS-VARIABLE: PYTHON_TEST_VERBOSITY
376# @DESCRIPTION: 2225# @DESCRIPTION:
377# Set this to a space separated list of use flags 2226# User-configurable verbosity of tests of Python modules.
378# the python slot in use must be built with. 2227# Supported values: 0, 1, 2, 3, 4.
2228PYTHON_TEST_VERBOSITY="${PYTHON_TEST_VERBOSITY:-1}"
379 2229
380# @ECLASS-VARIABLE: PYTHON_USE_WITH_OR 2230_python_test_hook() {
381# @DESCRIPTION: 2231 if [[ "$#" -ne 1 ]]; then
382# Set this to a space separated list of use flags 2232 die "${FUNCNAME}() requires 1 argument"
383# of which one must be turned on for the slot of 2233 fi
384# in use.
385 2234
386# @ECLASS-VARIABLE: PYTHON_USE_WITH_OPT 2235 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${FUNCNAME[3]}_$1_hook")" == "function" ]]; then
387# @DESCRIPTION: 2236 "${FUNCNAME[3]}_$1_hook"
388# Set this if you need to make either PYTHON_USE_WITH or 2237 fi
389# PYTHON_USE_WITH_OR atoms conditional under a use flag. 2238}
390 2239
391# @FUNCTION: python_pkg_setup 2240# @FUNCTION: python_execute_nosetests
2241# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
392# @DESCRIPTION: 2242# @DESCRIPTION:
393# Makes sure PYTHON_USE_WITH or PYTHON_USE_WITH_OR listed use flags 2243# Execute nosetests for all enabled Python ABIs.
394# are respected. Only exported if one of those variables is set. 2244# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
395if ! has ${EAPI:-0} 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then 2245# python_execute_nosetests_pre_hook() and python_execute_nosetests_post_hook(), if they are defined.
396 python_pkg_setup_fail() { 2246python_execute_nosetests() {
397 eerror "${1}" 2247 _python_check_python_pkg_setup_execution
398 die "${1}" 2248 _python_set_color_variables
2249
2250 local PYTHONPATH_template separate_build_dirs
2251
2252 while (($#)); do
2253 case "$1" in
2254 -P|--PYTHONPATH)
2255 PYTHONPATH_template="$2"
2256 shift
2257 ;;
2258 -s|--separate-build-dirs)
2259 separate_build_dirs="1"
2260 ;;
2261 --)
2262 shift
2263 break
2264 ;;
2265 -*)
2266 die "${FUNCNAME}(): Unrecognized option '$1'"
2267 ;;
2268 *)
2269 break
2270 ;;
2271 esac
2272 shift
2273 done
2274
2275 python_test_function() {
2276 local evaluated_PYTHONPATH
2277
2278 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2279
2280 _python_test_hook pre
2281
2282 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2283 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2284 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2285 else
2286 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2287 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2288 fi
2289
2290 _python_test_hook post
399 } 2291 }
400 2292 if _python_package_supporting_installation_for_multiple_python_abis; then
401 python_pkg_setup() { 2293 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
402 [[ ${PYTHON_USE_WITH_OPT} ]] && use !${PYTHON_USE_WITH_OPT} && return 2294 else
403 2295 if [[ -n "${separate_build_dirs}" ]]; then
404 python_version 2296 die "${FUNCNAME}(): Invalid usage"
405 local failed
406 local pyatom="dev-lang/python:${PYVER}"
407
408 for use in ${PYTHON_USE_WITH}; do
409 if ! has_version "${pyatom}[${use}]"; then
410 python_pkg_setup_fail \
411 "Please rebuild ${pyatom} with use flags: ${PYTHON_USE_WITH}"
412 fi 2297 fi
2298 python_test_function "$@" || die "Testing failed"
2299 fi
2300
2301 unset -f python_test_function
2302}
2303
2304# @FUNCTION: python_execute_py.test
2305# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
2306# @DESCRIPTION:
2307# Execute py.test for all enabled Python ABIs.
2308# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
2309# python_execute_py.test_pre_hook() and python_execute_py.test_post_hook(), if they are defined.
2310python_execute_py.test() {
2311 _python_check_python_pkg_setup_execution
2312 _python_set_color_variables
2313
2314 local PYTHONPATH_template separate_build_dirs
2315
2316 while (($#)); do
2317 case "$1" in
2318 -P|--PYTHONPATH)
2319 PYTHONPATH_template="$2"
2320 shift
2321 ;;
2322 -s|--separate-build-dirs)
2323 separate_build_dirs="1"
2324 ;;
2325 --)
2326 shift
2327 break
2328 ;;
2329 -*)
2330 die "${FUNCNAME}(): Unrecognized option '$1'"
2331 ;;
2332 *)
2333 break
2334 ;;
2335 esac
2336 shift
413 done 2337 done
414 2338
415 for use in ${PYTHON_USE_WITH_OR}; do 2339 python_test_function() {
416 if has_version "${pyatom}[${use}]"; then 2340 local evaluated_PYTHONPATH
417 return 2341
2342 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2343
2344 _python_test_hook pre
2345
2346 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2347 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL}
2348 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?"
2349 else
2350 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL}
2351 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?"
418 fi 2352 fi
419 done
420 2353
421 if [[ ${PYTHON_USE_WITH_OR} ]]; then 2354 _python_test_hook post
422 python_pkg_setup_fail \
423 "Please rebuild ${pyatom} with one of: ${PYTHON_USE_WITH_OR}"
424 fi
425 } 2355 }
2356 if _python_package_supporting_installation_for_multiple_python_abis; then
2357 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2358 else
2359 if [[ -n "${separate_build_dirs}" ]]; then
2360 die "${FUNCNAME}(): Invalid usage"
2361 fi
2362 python_test_function "$@" || die "Testing failed"
2363 fi
426 2364
427 EXPORT_FUNCTIONS pkg_setup 2365 unset -f python_test_function
2366}
428 2367
429 if [[ ${PYTHON_USE_WITH} ]]; then 2368# @FUNCTION: python_execute_trial
430 PYTHON_USE_WITH_ATOM="${PYTHON_ATOM}[${PYTHON_USE_WITH/ /,}]" 2369# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
431 elif [[ ${PYTHON_USE_WITH_OR} ]]; then 2370# @DESCRIPTION:
432 PYTHON_USE_WITH_ATOM="|| ( " 2371# Execute trial for all enabled Python ABIs.
433 for use in ${PYTHON_USE_WITH_OR}; do 2372# In ebuilds of packages supporting installation for multiple Python ABIs, this function
434 PYTHON_USE_WITH_ATOM=" 2373# calls python_execute_trial_pre_hook() and python_execute_trial_post_hook(), if they are defined.
435 ${PYTHON_USE_WITH_ATOM} 2374python_execute_trial() {
436 ${PYTHON_ATOM}[${use}]" 2375 _python_check_python_pkg_setup_execution
2376 _python_set_color_variables
2377
2378 local PYTHONPATH_template separate_build_dirs
2379
2380 while (($#)); do
2381 case "$1" in
2382 -P|--PYTHONPATH)
2383 PYTHONPATH_template="$2"
2384 shift
2385 ;;
2386 -s|--separate-build-dirs)
2387 separate_build_dirs="1"
2388 ;;
2389 --)
2390 shift
2391 break
2392 ;;
2393 -*)
2394 die "${FUNCNAME}(): Unrecognized option '$1'"
2395 ;;
2396 *)
2397 break
2398 ;;
2399 esac
2400 shift
437 done 2401 done
438 PYTHON_USE_WITH_ATOM="${PYTHON_USE_WITH_ATOM} )" 2402
2403 python_test_function() {
2404 local evaluated_PYTHONPATH
2405
2406 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2407
2408 _python_test_hook pre
2409
2410 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2411 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2412 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
2413 else
2414 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2415 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
439 fi 2416 fi
440 if [[ ${PYTHON_USE_WITH_OPT} ]]; then 2417
441 PYTHON_USE_WITH_ATOM="${PYTHON_USE_WITH_OPT}? ( ${PYTHON_USE_WITH_ATOM} )" 2418 _python_test_hook post
2419 }
2420 if _python_package_supporting_installation_for_multiple_python_abis; then
2421 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2422 else
2423 if [[ -n "${separate_build_dirs}" ]]; then
2424 die "${FUNCNAME}(): Invalid usage"
442 fi 2425 fi
443 DEPEND="${PYTHON_USE_WITH_ATOM}" 2426 python_test_function "$@" || die "Testing failed"
444 RDEPEND="${PYTHON_USE_WITH_ATOM}"
445fi 2427 fi
446 2428
447# @FUNCTION: python_disable_pyc 2429 unset -f python_test_function
448# @DESCRIPTION:
449# Tell Python not to automatically recompile modules to .pyc/.pyo
450# even if the timestamps/version stamps don't match. This is done
451# to protect sandbox.
452python_disable_pyc() {
453 export PYTHONDONTWRITEBYTECODE="1"
454} 2430}
2431
2432# ================================================================================================
2433# ======================= FUNCTIONS FOR HANDLING OF BYTE-COMPILED MODULES ========================
2434# ================================================================================================
455 2435
456# @FUNCTION: python_enable_pyc 2436# @FUNCTION: python_enable_pyc
457# @DESCRIPTION: 2437# @DESCRIPTION:
458# Tell Python to automatically recompile modules to .pyc/.pyo if the 2438# Tell Python to automatically recompile modules to .pyc/.pyo if the
459# timestamps/version stamps have changed. 2439# timestamps/version stamps have changed.
460python_enable_pyc() { 2440python_enable_pyc() {
2441 _python_check_python_pkg_setup_execution
2442
2443 if [[ "$#" -ne 0 ]]; then
2444 die "${FUNCNAME}() does not accept arguments"
2445 fi
2446
461 unset PYTHONDONTWRITEBYTECODE 2447 unset PYTHONDONTWRITEBYTECODE
462} 2448}
463 2449
2450# @FUNCTION: python_disable_pyc
2451# @DESCRIPTION:
2452# Tell Python not to automatically recompile modules to .pyc/.pyo
2453# even if the timestamps/version stamps do not match. This is done
2454# to protect sandbox.
464python_disable_pyc 2455python_disable_pyc() {
2456 _python_check_python_pkg_setup_execution
465 2457
466# @FUNCTION: python_need_rebuild 2458 if [[ "$#" -ne 0 ]]; then
467# @DESCRIPTION: Run without arguments, specifies that the package should be 2459 die "${FUNCNAME}() does not accept arguments"
468# rebuilt after a python upgrade. 2460 fi
469python_need_rebuild() {
470 python_version
471 export PYTHON_NEED_REBUILD=${PYVER}
472}
473 2461
474# @FUNCTION: python_get_includedir 2462 export PYTHONDONTWRITEBYTECODE="1"
475# @DESCRIPTION: 2463}
476# Run without arguments, returns the Python include directory. 2464
477python_get_includedir() { 2465_python_clean_compiled_modules() {
478 if [[ -n "${PYTHON_ABI}" ]]; then 2466 _python_initialize_prefix_variables
479 echo "/usr/include/python${PYTHON_ABI}" 2467 _python_set_color_variables
480 else 2468
481 python_version 2469 [[ "${FUNCNAME[1]}" =~ ^(python_mod_optimize|python_mod_cleanup)$ ]] || die "${FUNCNAME}(): Invalid usage"
482 echo "/usr/include/python${PYVER}" 2470
2471 local base_module_name compiled_file compiled_files=() dir path py_file root
2472
2473 # Strip trailing slash from EROOT.
2474 root="${EROOT%/}"
2475
2476 for path in "$@"; do
2477 compiled_files=()
2478 if [[ -d "${path}" ]]; then
2479 while read -d $'\0' -r compiled_file; do
2480 compiled_files+=("${compiled_file}")
2481 done < <(find "${path}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -print0)
2482
2483 if [[ "${EBUILD_PHASE}" == "postrm" ]]; then
2484 # Delete empty child directories.
2485 find "${path}" -type d | sort -r | while read -r dir; do
2486 if rmdir "${dir}" 2> /dev/null; then
2487 echo "${_CYAN}<<< ${dir}${_NORMAL}"
2488 fi
2489 done
2490 fi
2491 elif [[ "${path}" == *.py ]]; then
2492 base_module_name="${path##*/}"
2493 base_module_name="${base_module_name%.py}"
2494 if [[ -d "${path%/*}/__pycache__" ]]; then
2495 while read -d $'\0' -r compiled_file; do
2496 compiled_files+=("${compiled_file}")
2497 done < <(find "${path%/*}/__pycache__" "(" -name "${base_module_name}.*.py[co]" -o -name "${base_module_name}\$py.class" ")" -print0)
2498 fi
2499 compiled_files+=("${path}c" "${path}o" "${path%.py}\$py.class")
483 fi 2500 fi
484}
485 2501
486# @FUNCTION: python_get_libdir 2502 for compiled_file in "${compiled_files[@]}"; do
487# @DESCRIPTION: 2503 [[ ! -f "${compiled_file}" ]] && continue
488# Run without arguments, returns the Python library directory. 2504 dir="${compiled_file%/*}"
489python_get_libdir() { 2505 dir="${dir##*/}"
490 if [[ -n "${PYTHON_ABI}" ]]; then 2506 if [[ "${compiled_file}" == *.py[co] ]]; then
491 echo "/usr/$(get_libdir)/python${PYTHON_ABI}" 2507 if [[ "${dir}" == "__pycache__" ]]; then
2508 base_module_name="${compiled_file##*/}"
2509 base_module_name="${base_module_name%.*py[co]}"
2510 base_module_name="${base_module_name%.*}"
2511 py_file="${compiled_file%__pycache__/*}${base_module_name}.py"
2512 else
2513 py_file="${compiled_file%[co]}"
2514 fi
2515 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2516 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2517 else
2518 [[ -f "${py_file}" ]] && continue
2519 fi
2520 echo "${_BLUE}<<< ${compiled_file%[co]}[co]${_NORMAL}"
2521 rm -f "${compiled_file%[co]}"[co]
2522 elif [[ "${compiled_file}" == *\$py.class ]]; then
2523 if [[ "${dir}" == "__pycache__" ]]; then
2524 base_module_name="${compiled_file##*/}"
2525 base_module_name="${base_module_name%\$py.class}"
2526 py_file="${compiled_file%__pycache__/*}${base_module_name}.py"
2527 else
2528 py_file="${compiled_file%\$py.class}.py"
2529 fi
2530 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2531 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2532 else
2533 [[ -f "${py_file}" ]] && continue
2534 fi
2535 echo "${_BLUE}<<< ${compiled_file}${_NORMAL}"
2536 rm -f "${compiled_file}"
492 else 2537 else
493 python_version 2538 die "${FUNCNAME}(): Unrecognized file type: '${compiled_file}'"
494 echo "/usr/$(get_libdir)/python${PYVER}"
495 fi 2539 fi
496}
497 2540
498# @FUNCTION: python_get_sitedir 2541 # Delete empty parent directories.
499# @DESCRIPTION: 2542 dir="${compiled_file%/*}"
500# Run without arguments, returns the Python site-packages directory. 2543 while [[ "${dir}" != "${root}" ]]; do
501python_get_sitedir() { 2544 if rmdir "${dir}" 2> /dev/null; then
502 echo "$(python_get_libdir)/site-packages" 2545 echo "${_CYAN}<<< ${dir}${_NORMAL}"
2546 else
2547 break
2548 fi
2549 dir="${dir%/*}"
2550 done
2551 done
2552 done
503} 2553}
504 2554
505# @FUNCTION: python_tkinter_exists
506# @DESCRIPTION:
507# Run without arguments, checks if python was compiled with Tkinter
508# support. If not, prints an error message and dies.
509python_tkinter_exists() {
510 if ! python -c "import Tkinter" >/dev/null 2>&1; then
511 eerror "You need to recompile python with Tkinter support."
512 eerror "Try adding: 'dev-lang/python tk'"
513 eerror "in to /etc/portage/package.use"
514 echo
515 die "missing tkinter support with installed python"
516 fi
517}
518
519# @FUNCTION: python_mod_exists 2555# @FUNCTION: python_mod_optimize
520# @USAGE: <module> 2556# @USAGE: [--allow-evaluated-non-sitedir-paths] [-d directory] [-f] [-l] [-q] [-x regular_expression] [--] <file|directory> [files|directories]
521# @DESCRIPTION: 2557# @DESCRIPTION:
522# Run with the module name as an argument. it will check if a 2558# Byte-compile specified Python modules.
523# python module is installed and loadable. it will return 2559# -d, -f, -l, -q and -x options passed to this function are passed to compileall.py.
524# TRUE(0) if the module exists, and FALSE(1) if the module does
525# not exist.
526# 2560#
527# Example:
528# if python_mod_exists gtk; then
529# echo "gtk support enabled"
530# fi
531python_mod_exists() {
532 [[ "$1" ]] || die "${FUNCNAME} requires an argument!"
533 python -c "import $1" &>/dev/null
534}
535
536# @FUNCTION: python_mod_compile
537# @USAGE: <file> [more files ...]
538# @DESCRIPTION:
539# Given filenames, it will pre-compile the module's .pyc and .pyo.
540# This function should only be run in pkg_postinst()
541#
542# Example:
543# python_mod_compile /usr/lib/python2.3/site-packages/pygoogle.py
544#
545python_mod_compile() {
546 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
547 die "${FUNCNAME}() cannot be used in this EAPI"
548 fi
549
550 local f myroot myfiles=()
551
552 # Check if phase is pkg_postinst()
553 [[ ${EBUILD_PHASE} != postinst ]] &&\
554 die "${FUNCNAME} should only be run in pkg_postinst()"
555
556 # allow compiling for older python versions
557 if [[ "${PYTHON_OVERRIDE_PYVER}" ]]; then
558 PYVER=${PYTHON_OVERRIDE_PYVER}
559 else
560 python_version
561 fi
562
563 # strip trailing slash
564 myroot="${ROOT%/}"
565
566 # respect ROOT
567 for f in "$@"; do
568 [[ -f "${myroot}/${f}" ]] && myfiles+=("${myroot}/${f}")
569 done
570
571 if ((${#myfiles[@]})); then
572 python${PYVER} ${myroot}/usr/$(get_libdir)/python${PYVER}/py_compile.py "${myfiles[@]}"
573 python${PYVER} -O ${myroot}/usr/$(get_libdir)/python${PYVER}/py_compile.py "${myfiles[@]}" &> /dev/null
574 else
575 ewarn "No files to compile!"
576 fi
577}
578
579# @FUNCTION: python_mod_optimize
580# @USAGE: [options] [directory|file]
581# @DESCRIPTION:
582# If no arguments supplied, it will recompile not recursively all modules
583# under sys.path (eg. /usr/lib/python2.6, /usr/lib/python2.6/site-packages).
584#
585# If supplied with arguments, it will recompile all modules recursively
586# in the supplied directory.
587# This function should only be run in pkg_postinst(). 2561# This function can be used only in pkg_postinst() phase.
588#
589# Options passed to this function are passed to compileall.py.
590#
591# Example:
592# python_mod_optimize ctypesgencore
593python_mod_optimize() { 2562python_mod_optimize() {
594 # Check if phase is pkg_postinst(). 2563 if [[ "${EBUILD_PHASE}" != "postinst" ]]; then
595 [[ ${EBUILD_PHASE} != "postinst" ]] && die "${FUNCNAME} should only be run in pkg_postinst()" 2564 die "${FUNCNAME}() can be used only in pkg_postinst() phase"
2565 fi
596 2566
2567 _python_check_python_pkg_setup_execution
2568 _python_initialize_prefix_variables
2569
2570 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
2571 # PYTHON_ABI variable cannot be local in packages not supporting installation for multiple Python ABIs.
2572 local allow_evaluated_non_sitedir_paths="0" dir dirs=() evaluated_dirs=() evaluated_files=() file files=() iterated_PYTHON_ABIS options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_dirs=() site_packages_files=()
2573
2574 if _python_package_supporting_installation_for_multiple_python_abis; then
597 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2575 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
598 local dir file options=() other_dirs=() other_files=() PYTHON_ABI return_code root site_packages_absolute_dirs=() site_packages_dirs=() site_packages_absolute_files=() site_packages_files=() 2576 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2577 fi
2578 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
2579 else
2580 if has "${EAPI:-0}" 0 1 2 3; then
2581 iterated_PYTHON_ABIS="${PYTHON_ABI:=$(PYTHON --ABI)}"
2582 else
2583 iterated_PYTHON_ABIS="${PYTHON_ABI}"
2584 fi
2585 fi
599 2586
600 # Strip trailing slash from ROOT. 2587 # Strip trailing slash from EROOT.
601 root="${ROOT%/}" 2588 root="${EROOT%/}"
602 2589
603 # Respect ROOT and options passed to compileall.py.
604 while (($#)); do 2590 while (($#)); do
605 case "$1" in 2591 case "$1" in
2592 --allow-evaluated-non-sitedir-paths)
2593 allow_evaluated_non_sitedir_paths="1"
2594 ;;
606 -l|-f|-q) 2595 -l|-f|-q)
607 options+=("$1") 2596 options+=("$1")
608 ;; 2597 ;;
609 -d|-x) 2598 -d|-x)
610 options+=("$1" "$2") 2599 options+=("$1" "$2")
611 shift 2600 shift
612 ;; 2601 ;;
2602 --)
2603 shift
2604 break
2605 ;;
613 -*) 2606 -*)
614 ewarn "${FUNCNAME}: Ignoring compile option $1" 2607 die "${FUNCNAME}(): Unrecognized option '$1'"
615 ;; 2608 ;;
616 *) 2609 *)
617 if [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
618 die "${FUNCNAME} doesn't support absolute paths of directories/files in site-packages directories"
619 elif [[ "$1" =~ ^/ ]]; then
620 if [[ -d "${root}/$1" ]]; then
621 other_dirs+=("${root}/$1")
622 elif [[ -f "${root}/$1" ]]; then
623 other_files+=("${root}/$1")
624 elif [[ -e "${root}/$1" ]]; then
625 ewarn "'${root}/$1' is not a file or a directory!"
626 else
627 ewarn "'${root}/$1' doesn't exist!"
628 fi
629 else
630 for PYTHON_ABI in ${PYTHON_ABIS}; do
631 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
632 site_packages_dirs+=("$1")
633 break 2610 break
634 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
635 site_packages_files+=("$1")
636 break
637 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then
638 ewarn "'$1' is not a file or a directory!"
639 else
640 ewarn "'$1' doesn't exist!"
641 fi
642 done
643 fi
644 ;; 2611 ;;
645 esac 2612 esac
646 shift 2613 shift
647 done 2614 done
648 2615
2616 if [[ "${allow_evaluated_non_sitedir_paths}" == "1" ]] && ! _python_package_supporting_installation_for_multiple_python_abis; then
2617 die "${FUNCNAME}(): '--allow-evaluated-non-sitedir-paths' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2618 fi
2619
2620 if [[ "$#" -eq 0 ]]; then
2621 die "${FUNCNAME}(): Missing files or directories"
2622 fi
2623
2624 while (($#)); do
2625 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2626 die "${FUNCNAME}(): Invalid argument '$1'"
2627 elif ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
2628 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories"
2629 elif [[ "$1" =~ ^/ ]]; then
2630 if _python_package_supporting_installation_for_multiple_python_abis; then
2631 if [[ "${allow_evaluated_non_sitedir_paths}" != "1" ]]; then
2632 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
2633 fi
2634 if [[ "$1" != *\$* ]]; then
2635 die "${FUNCNAME}(): '$1' has invalid syntax"
2636 fi
2637 if [[ "$1" == *.py ]]; then
2638 evaluated_files+=("$1")
2639 else
2640 evaluated_dirs+=("$1")
2641 fi
2642 else
2643 if [[ -d "${root}$1" ]]; then
2644 other_dirs+=("${root}$1")
2645 elif [[ -f "${root}$1" ]]; then
2646 other_files+=("${root}$1")
2647 elif [[ -e "${root}$1" ]]; then
2648 eerror "${FUNCNAME}(): '${root}$1' is not a regular file or a directory"
2649 else
2650 eerror "${FUNCNAME}(): '${root}$1' does not exist"
2651 fi
2652 fi
2653 else
2654 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2655 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
2656 site_packages_dirs+=("$1")
2657 break
2658 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
2659 site_packages_files+=("$1")
2660 break
2661 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then
2662 eerror "${FUNCNAME}(): '$1' is not a regular file or a directory"
2663 else
2664 eerror "${FUNCNAME}(): '$1' does not exist"
2665 fi
2666 done
2667 fi
2668 shift
2669 done
2670
649 # Set additional options. 2671 # Set additional options.
650 options+=("-q") 2672 options+=("-q")
651 2673
652 for PYTHON_ABI in ${PYTHON_ABIS}; do 2674 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
653 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})); then 2675 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then
654 return_code="0" 2676 return_code="0"
655 ebegin "Compilation and optimization of Python modules for Python ${PYTHON_ABI}" 2677 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)"
656 if ((${#site_packages_dirs[@]})); then 2678 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then
657 for dir in "${site_packages_dirs[@]}"; do 2679 for dir in "${site_packages_dirs[@]}"; do
658 site_packages_absolute_dirs+=("${root}$(python_get_sitedir)/${dir}") 2680 dirs+=("${root}$(python_get_sitedir)/${dir}")
659 done 2681 done
2682 for dir in "${evaluated_dirs[@]}"; do
2683 eval "dirs+=(\"\${root}${dir}\")"
2684 done
660 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" || return_code="1" 2685 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" || return_code="1"
2686 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
661 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" &> /dev/null || return_code="1" 2687 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1"
662 fi 2688 fi
663 if ((${#site_packages_files[@]})); then 2689 _python_clean_compiled_modules "${dirs[@]}"
2690 fi
2691 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then
664 for file in "${site_packages_files[@]}"; do 2692 for file in "${site_packages_files[@]}"; do
665 site_packages_absolute_files+=("${root}$(python_get_sitedir)/${file}") 2693 files+=("${root}$(python_get_sitedir)/${file}")
666 done 2694 done
2695 for file in "${evaluated_files[@]}"; do
2696 eval "files+=(\"\${root}${file}\")"
2697 done
667 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" || return_code="1" 2698 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" || return_code="1"
2699 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
668 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" &> /dev/null || return_code="1" 2700 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" &> /dev/null || return_code="1"
2701 fi
2702 _python_clean_compiled_modules "${files[@]}"
669 fi 2703 fi
670 eend "${return_code}" 2704 eend "${return_code}"
671 fi 2705 fi
672 unset site_packages_absolute_dirs site_packages_absolute_files 2706 unset dirs files
673 done 2707 done
674 2708
675 # Don't use PYTHON_ABI in next calls to python_get_libdir(). 2709 if _python_package_supporting_installation_for_multiple_python_abis; then
2710 # Restore previous value of PYTHON_ABI.
2711 if [[ -n "${previous_PYTHON_ABI}" ]]; then
2712 PYTHON_ABI="${previous_PYTHON_ABI}"
2713 else
676 unset PYTHON_ABI 2714 unset PYTHON_ABI
2715 fi
2716 fi
677 2717
678 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then 2718 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then
679 return_code="0" 2719 return_code="0"
680 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for Python ${PYVER}..." 2720 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version)"
681 if ((${#other_dirs[@]})); then 2721 if ((${#other_dirs[@]})); then
682 python${PYVER} "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1" 2722 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1"
2723 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
683 python${PYVER} -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1" 2724 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
2725 fi
2726 _python_clean_compiled_modules "${other_dirs[@]}"
684 fi 2727 fi
685 if ((${#other_files[@]})); then 2728 if ((${#other_files[@]})); then
686 python${PYVER} "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1" 2729 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1"
2730 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
687 python${PYVER} -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1" 2731 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1"
2732 fi
2733 _python_clean_compiled_modules "${other_files[@]}"
688 fi 2734 fi
689 eend "${return_code}" 2735 eend "${return_code}"
690 fi 2736 fi
691 else 2737 else
2738 # Deprecated part of python_mod_optimize()
2739 ewarn
2740 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
2741 ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-08-01."
2742 ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
2743 ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
2744 ewarn
2745
692 local myroot mydirs=() myfiles=() myopts=() return_code="0" 2746 local myroot mydirs=() myfiles=() myopts=() return_code="0"
693 2747
694 # strip trailing slash 2748 # strip trailing slash
695 myroot="${ROOT%/}" 2749 myroot="${EROOT%/}"
696 2750
697 # respect ROOT and options passed to compileall.py 2751 # respect EROOT and options passed to compileall.py
698 while (($#)); do 2752 while (($#)); do
699 case "$1" in 2753 case "$1" in
700 -l|-f|-q) 2754 -l|-f|-q)
701 myopts+=("$1") 2755 myopts+=("$1")
702 ;; 2756 ;;
703 -d|-x) 2757 -d|-x)
704 myopts+=("$1" "$2") 2758 myopts+=("$1" "$2")
705 shift 2759 shift
706 ;; 2760 ;;
2761 --)
2762 shift
2763 break
2764 ;;
707 -*) 2765 -*)
708 ewarn "${FUNCNAME}: Ignoring compile option $1" 2766 die "${FUNCNAME}(): Unrecognized option '$1'"
709 ;; 2767 ;;
710 *) 2768 *)
711 if [[ -d "${myroot}"/$1 ]]; then 2769 break
712 mydirs+=("${myroot}/$1")
713 elif [[ -f "${myroot}"/$1 ]]; then
714 # Files are passed to python_mod_compile which is ROOT-aware
715 myfiles+=("$1")
716 elif [[ -e "${myroot}/$1" ]]; then
717 ewarn "${myroot}/$1 is not a file or directory!"
718 else
719 ewarn "${myroot}/$1 doesn't exist!"
720 fi
721 ;; 2770 ;;
722 esac 2771 esac
723 shift 2772 shift
724 done 2773 done
725 2774
726 # allow compiling for older python versions 2775 if [[ "$#" -eq 0 ]]; then
727 if [ -n "${PYTHON_OVERRIDE_PYVER}" ]; then 2776 die "${FUNCNAME}(): Missing files or directories"
728 PYVER=${PYTHON_OVERRIDE_PYVER} 2777 fi
2778
2779 while (($#)); do
2780 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2781 die "${FUNCNAME}(): Invalid argument '$1'"
2782 elif [[ -d "${myroot}/${1#/}" ]]; then
2783 mydirs+=("${myroot}/${1#/}")
2784 elif [[ -f "${myroot}/${1#/}" ]]; then
2785 myfiles+=("${myroot}/${1#/}")
2786 elif [[ -e "${myroot}/${1#/}" ]]; then
2787 eerror "${FUNCNAME}(): ${myroot}/${1#/} is not a regular file or directory"
729 else 2788 else
730 python_version 2789 eerror "${FUNCNAME}(): ${myroot}/${1#/} does not exist"
731 fi 2790 fi
2791 shift
2792 done
732 2793
733 # set additional opts 2794 # set additional opts
734 myopts+=(-q) 2795 myopts+=(-q)
735 2796
736 ebegin "Byte compiling python modules for python-${PYVER} .." 2797 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2798
2799 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)"
737 if ((${#mydirs[@]})); then 2800 if ((${#mydirs[@]})); then
738 python${PYVER} \ 2801 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" || return_code="1"
739 "${myroot}"/usr/$(get_libdir)/python${PYVER}/compileall.py \ 2802 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1"
740 "${myopts[@]}" "${mydirs[@]}" || return_code="1" 2803 _python_clean_compiled_modules "${mydirs[@]}"
741 python${PYVER} -O \
742 "${myroot}"/usr/$(get_libdir)/python${PYVER}/compileall.py \
743 "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1"
744 fi 2804 fi
745 2805
746 if ((${#myfiles[@]})); then 2806 if ((${#myfiles[@]})); then
2807 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" || return_code="1"
2808 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null || return_code="1"
747 python_mod_compile "${myfiles[@]}" 2809 _python_clean_compiled_modules "${myfiles[@]}"
748 fi 2810 fi
749 2811
750 eend "${return_code}" 2812 eend "${return_code}"
751 fi 2813 fi
752} 2814}
753 2815
754# @FUNCTION: python_mod_cleanup 2816# @FUNCTION: python_mod_cleanup
755# @USAGE: [directory] 2817# @USAGE: [--allow-evaluated-non-sitedir-paths] [--] <file|directory> [files|directories]
756# @DESCRIPTION: 2818# @DESCRIPTION:
757# Run with optional arguments, where arguments are directories of 2819# Delete orphaned byte-compiled Python modules corresponding to specified Python modules.
758# python modules. If none given, it will look in /usr/lib/python[0-9].[0-9].
759# 2820#
760# It will recursively scan all compiled Python modules in the directories and
761# determine if they are orphaned (i.e. their corresponding .py files are missing.)
762# If they are, then it will remove their corresponding .pyc and .pyo files.
763#
764# This function should only be run in pkg_postrm(). 2821# This function can be used only in pkg_postrm() phase.
765python_mod_cleanup() { 2822python_mod_cleanup() {
766 local PYTHON_ABI SEARCH_PATH=() root src_py 2823 if [[ "${EBUILD_PHASE}" != "postrm" ]]; then
2824 die "${FUNCNAME}() can be used only in pkg_postrm() phase"
2825 fi
767 2826
768 # Check if phase is pkg_postrm(). 2827 _python_check_python_pkg_setup_execution
769 [[ ${EBUILD_PHASE} != "postrm" ]] && die "${FUNCNAME} should only be run in pkg_postrm()" 2828 _python_initialize_prefix_variables
770 2829
2830 local allow_evaluated_non_sitedir_paths="0" dir iterated_PYTHON_ABIS PYTHON_ABI="${PYTHON_ABI}" root search_paths=() sitedir
2831
2832 if _python_package_supporting_installation_for_multiple_python_abis; then
2833 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
2834 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2835 fi
2836 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
2837 else
2838 if has "${EAPI:-0}" 0 1 2 3; then
2839 iterated_PYTHON_ABIS="${PYTHON_ABI:-$(PYTHON --ABI)}"
2840 else
2841 iterated_PYTHON_ABIS="${PYTHON_ABI}"
2842 fi
2843 fi
2844
771 # Strip trailing slash from ROOT. 2845 # Strip trailing slash from EROOT.
772 root="${ROOT%/}" 2846 root="${EROOT%/}"
773 2847
774 if (($#)); then 2848 while (($#)); do
775 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2849 case "$1" in
2850 --allow-evaluated-non-sitedir-paths)
2851 allow_evaluated_non_sitedir_paths="1"
2852 ;;
2853 --)
2854 shift
2855 break
2856 ;;
2857 -*)
2858 die "${FUNCNAME}(): Unrecognized option '$1'"
2859 ;;
2860 *)
2861 break
2862 ;;
2863 esac
2864 shift
2865 done
2866
2867 if [[ "${allow_evaluated_non_sitedir_paths}" == "1" ]] && ! _python_package_supporting_installation_for_multiple_python_abis; then
2868 die "${FUNCNAME}(): '--allow-evaluated-non-sitedir-paths' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2869 fi
2870
2871 if [[ "$#" -eq 0 ]]; then
2872 die "${FUNCNAME}(): Missing files or directories"
2873 fi
2874
2875 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
776 while (($#)); do 2876 while (($#)); do
2877 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2878 die "${FUNCNAME}(): Invalid argument '$1'"
777 if [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then 2879 elif ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
778 die "${FUNCNAME} doesn't support absolute paths of directories/files in site-packages directories" 2880 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories"
779 elif [[ "$1" =~ ^/ ]]; then 2881 elif [[ "$1" =~ ^/ ]]; then
780 SEARCH_PATH+=("${root}/${1#/}") 2882 if _python_package_supporting_installation_for_multiple_python_abis; then
2883 if [[ "${allow_evaluated_non_sitedir_paths}" != "1" ]]; then
2884 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
2885 fi
2886 if [[ "$1" != *\$* ]]; then
2887 die "${FUNCNAME}(): '$1' has invalid syntax"
2888 fi
2889 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2890 eval "search_paths+=(\"\${root}$1\")"
2891 done
781 else 2892 else
2893 search_paths+=("${root}$1")
2894 fi
2895 else
782 for PYTHON_ABI in ${PYTHON_ABIS}; do 2896 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
783 SEARCH_PATH+=("${root}$(python_get_sitedir)/$1") 2897 search_paths+=("${root}$(python_get_sitedir)/$1")
784 done 2898 done
785 fi 2899 fi
786 shift 2900 shift
787 done
788 else
789 SEARCH_PATH=("${@#/}")
790 SEARCH_PATH=("${SEARCH_PATH[@]/#/${root}/}")
791 fi
792 else
793 SEARCH_PATH=("${root}"/usr/lib*/python*/site-packages)
794 fi
795
796 for path in "${SEARCH_PATH[@]}"; do
797 [[ ! -d "${path}" ]] && continue
798 einfo "Cleaning orphaned Python bytecode from ${path} .."
799 find "${path}" -name '*.py[co]' -print0 | while read -rd ''; do
800 src_py="${REPLY%[co]}"
801 [[ -f "${src_py}" || (! -f "${src_py}c" && ! -f "${src_py}o") ]] && continue
802 einfo "Purging ${src_py}[co]"
803 rm -f "${src_py}"[co]
804 done 2901 done
2902 else
2903 # Deprecated part of python_mod_cleanup()
2904 ewarn
2905 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
2906 ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-08-01."
2907 ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
2908 ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
2909 ewarn
805 2910
806 # Attempt to remove directories that may be empty. 2911 search_paths=("${@#/}")
807 find "${path}" -type d | sort -r | while read -r dir; do 2912 search_paths=("${search_paths[@]/#/${root}/}")
808 rmdir "${dir}" 2>/dev/null && einfo "Removing empty directory ${dir}" 2913 fi
809 done 2914
810 done 2915 _python_clean_compiled_modules "${search_paths[@]}"
811} 2916}
2917
2918# ================================================================================================
2919# ===================================== DEPRECATED FUNCTIONS =====================================
2920# ================================================================================================

Legend:
Removed from v.1.66  
changed lines
  Added in v.1.115

  ViewVC Help
Powered by ViewVC 1.1.20